 <?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ('joomla.application.component.controller');

class adagencyAdminControlleradagencyCampaigns extends adagencyAdminController {
	var $_model = null;
	
	function __construct () {
		parent::__construct();
		$this->registerTask ("add", "edit");
		$this->registerTask ("", "listCampaigns");
		$this->_model =& $this->getModel("adagencyCampaigns");
		$this->registerTask ("unpublish", "publish");	
	}

	function listCampaigns() {
		$view = $this->getView("adagencyCampaigns", "html");
		$view->setModel($this->_model, true);
		$view->display();
	}

	function edit () {
		JRequest::setVar ("hidemainmenu", 1);
		$view = $this->getView("adagencyCampaigns", "html");
		$view->setLayout("editForm");
		$view->setModel($this->_model, true);
		$model =& $this->getModel("adagencyConfig");
		$view->setModel($model);
		$view->editForm();
	}

	function save () {
		if ($this->_model->store() ) {
			$msg = JText::_('AD_CMP_SAVED');
		} else {
			$msg = JText::_('AD_CMP_NOT_SAVED');
		}
		$link = "index.php?option=com_adagency&controller=adagencyCampaigns";
		$this->setRedirect($link, $msg);
	}

	function remove () {
		if (!$this->_model->delete()) {
			$msg = JText::_('AD_CMP_CANTREMOVED');
		} else {
		 	$msg = JText::_('AD_CMP_REMOVED');
		}
		
		$link = "index.php?option=com_adagency&controller=adagencyCampaigns";
		$this->setRedirect($link, $msg);
	}

	function cancel () {
	 	$msg = JText::_('AD_OP_CANCELED');
		$link = "index.php?option=com_adagency&controller=adagencyCampaigns";
		$this->setRedirect($link, $msg);
	}
	
	function approve () { 
		$res = $this->_model->publish();
		if (!$res) {
			$msg = JText::_('AD_CMP_UNERROR');
		} elseif ($res == -1) {
		 	$msg = JText::_('AD_CMP_UNNAP');
		} elseif ($res == 1) {
			$msg = JText::_('AD_CMP_APPV');
		} else {
                 	$msg = JText::_('AD_CMP_UNERROR');
		}
		$link = "index.php?option=com_adagency&controller=adagencyCampaigns";
		$this->setRedirect($link, $msg);
	}
	
	function pending(){
		$res = $this->_model->publish();
		if(!isset($res)) {
			$msg = JText::_('AD_CMP_UNERROR');
		} elseif ($res == 0){
			$msg = JText::_('ADAG_PENMSG');
		}
		$link = "index.php?option=com_adagency&controller=adagencyCampaigns";
		$this->setRedirect($link,$msg);
	}

	function unapprove () {
		$res = $this->_model->pbl();
		if (!$res) {
			$msg = JText::_('AD_CMP_ERROR');
		} elseif ($res == -1) {
		 	$msg = JText::_('AD_CMP_UNNAP');
		} elseif ($res == 1) {
			$msg = JText::_('AD_CMP_APPV');
		} else {
           	$msg = JText::_('AD_CMP_ERROR');
		}
		$link = "index.php?option=com_adagency&controller=adagencyCampaigns";
		$this->setRedirect($link, $msg);
	}
		
	function publish () { 
		$res = $this->_model->pbl();
		if (!$res) { 
			$msg = JText::_('AD_CMP_UNERROR');
		} elseif ($res == -1) {
		 	$msg = JText::_('AD_CMP_UNNAP');
		} elseif ($res == 1) {
			$msg = JText::_('AD_CMP_APPV');
		} else {
	       	$msg = JText::_('AD_CMP_UNERROR');
		}
		$link = "index.php?option=com_adagency&controller=adagencyCampaigns";
		$this->setRedirect($link, $msg);
	}
	
	function unpublish () {
		$res = $this->_model->publish();
		if (!$res) {
			$msg = JText::_('AD_CMP_ERROR');
		} elseif ($res == -1) {
		 	$msg = JText::_('AD_CMP_UNNAP');
		} elseif ($res == 1) {
			$msg = JText::_('AD_CMP_APPV');
		} else {
          	$msg = JText::_('AD_CMP_ERROR');
		}
		
		$link = "index.php?option=com_adagency&controller=adagencyCampaigns";
		$this->setRedirect($link, $msg);
	}
		
	function pause () {
		if (!$this->_model->pause()) {
			$msg = JText::_('AD_CMP_CANTPAUSE');
		} else {
		 	$msg = JText::_('AD_CMP_PAUSED');
		}
		$link = "index.php?option=com_adagency&controller=adagencyCampaigns";
		$this->setRedirect($link, $msg);
	}
		
	function unpause () {
		if (!$this->_model->unpause()) {
			$msg = JText::_('AD_CMP_CANTUNPAUSE');
		} else {
		 	$msg = JText::_('AD_CMP_UNPAUSED');
		}
		$link = "index.php?option=com_adagency&controller=adagencyCampaigns";
		$this->setRedirect($link, $msg);
	}
};
?>