 <?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ('joomla.application.component.controller');

class adagencyAdminControlleradagencyOrders extends adagencyAdminController {
	var $_model = null;
	
	function __construct () {
		parent::__construct();
		$this->registerTask ("", "listOrders");
		$this->_model =& $this->getModel("adagencyOrder");
	}

	function listOrders() {
		$view = $this->getView("adagencyOrders", "html");
		$view->setModel($this->_model, true);
		$model =& $this->getModel("adagencyConfig");
		$view->setModel($model);
		$view->display();
	}
	
	function confirm() {
		if (!$this->_model->confirm()) {
			$msg = JText::_('AD_ORD_NOTCONF');
		} else {
		 	$msg = JText::_('AD_ORD_CONF');
		}
		$link = "index.php?option=com_adagency&controller=adagencyOrders";
		$this->setRedirect($link, $msg);
	}

	function edit () {
		JRequest::setVar ("hidemainmenu", 1);
		$view = $this->getView("adagencyOrders", "html");
		$view->setLayout("editForm");
		$view->setModel($this->_model, true);
		$model =& $this->getModel("adagencyConfig");
		$view->setModel($model);
		$view->editForm();
	}
	
	function add () {
		JRequest::setVar ("hidemainmenu", 1);
		$view = $this->getView("adagencyOrders", "html");
		$view->setLayout("addOrder");
		$view->setModel($this->_model, true);
		$model =& $this->getModel("adagencyConfig");
		$view->setModel($model);
		$view->addOrder();
	}	

	function save () {
		if ($this->_model->store() ) {
			$msg = JText::_('ORDSAVED');
		} else {
			$msg = JText::_('ORDFAILED');
		}
		$link = "index.php?option=com_adagency&controller=adagencyOrders";
		$this->setRedirect($link, $msg);
	}
	
	function savenew () {
		if ($this->_model->storenew() ) {
			$msg = JText::_('ORDSAVED');
		} else {
			$msg = JText::_('ORDFAILED');
		}
		$link = "index.php?option=com_adagency&controller=adagencyOrders";
		$this->setRedirect($link, $msg);
	}

	function remove () {
		if (!$this->_model->delete()) {
			$msg = JText::_('ORDREMERR');
		} else {
		 	$msg = JText::_('ORDREMSUCC');
		}
		$link = "index.php?option=com_adagency&controller=adagencyOrders";
		$this->setRedirect($link, $msg);
	}
	
	function delete () {
		if (!$this->_model->remove()) {
			$msg = JText::_('ORDREMERR');
		} else {
		 	$msg = JText::_('ORDREMSUCC');
		}
		$link = "index.php?option=com_adagency&controller=adagencyOrders";
		$this->setRedirect($link, $msg);
	}

	function cancel () {
	 	$msg = JText::_('ORDCANCEL');
		$link = "index.php?option=com_adagency&controller=adagencyOrders";
		$this->setRedirect($link, $msg);
	}

	function publish () {
		$res = $this->_model->publish();
		if (!$res) {
			$msg = JText::_('ORDBLOCKERR');
		} elseif ($res == -1) {
		 	$msg = JText::_('ORDUNPUB');
		} elseif ($res == 1) {
			$msg = JText::_('ORDPUB');
		} else {
                 	$msg = JText::_('ORDUNSPEC');
		}
		$link = "index.php?option=com_adagency&controller=adagencyOrders";
		$this->setRedirect($link, $msg);
	}

};
?>