 <?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ("joomla.aplication.component.model");

class adagencyAdminModeladagencygeo extends JModel {
	
	function __construct () {
		parent::__construct();
		global $mainframe, $option;
		// Get the pagination request variables
		$limit = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );
		$this->setState('limit', $limit); // Set the limit variable for query later on
		$this->setState('limitstart', $limitstart);
	}
	
	function getPagination(){
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))	{
			jimport('joomla.html.pagination');
			if (!isset($this->_total)) $this->getChannels();
			$this->_pagination = new JPagination( $this->_total, $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}	
	
	function getConf(){
		$configs = $this->getInstance("adagencyConfig", "adagencyAdminModel");
		$configs = $configs->getConfigs();
		return $configs;
	}
	
	function getUsers(){
		$db = &JFactory::getDBO();
		$sql = 'SELECT DISTINCT(c.created_by) AS id, u.name, u.username 
				FROM `#__ad_agency_channels` as c 
				LEFT JOIN `#__users` as u 
				ON c.created_by = u.id';
		$db->setQuery($sql);
		return $db->loadObjectList();
	}
	
	function getUL(){
		$users = $this->getUsers();
		$created_by = JRequest::getVar('created_by');
		if(!isset($created_by)) { 
			if(isset($_SESSION['created_by'])) { $created_by = $_SESSION['created_by']; }
		}
		if($users != NULL) {
			$output = '&nbsp;&nbsp;&nbsp;&nbsp;'.JText::_('ADAG_CREATED_BY').'&nbsp;&nbsp;<select name="created_by" onchange="document.topform1.submit();"><option value="YN">'.JText::_('VIEWAD_SEARCH_SELECT').'</option>';
			foreach($users as $element){
				$selected = NULL;
				if($element->id == $created_by) {
					$selected = " selected='selected' ";
				}
				$output .= '<option'.$selected.' value="'.$element->id.'">'.$element->name.' ('.$element->username.')</option>';
			}
			$output .= '</select>';
			return $output;
		} else { return NULL; }
	}
	
	function getChannels() {
		$data = JRequest::get('post');
		$db = &JFactory::getDBO();
		if(isset($data['search_channel'])) {
			$where = " WHERE c.name LIKE '%".$data['search_channel']."%' ";
			$_SESSION['search_channel'] = $data['search_channel'];
		} elseif(isset($_SESSION['search_channel'])) {
			$where = " WHERE c.name LIKE '%".$_SESSION['search_channel']."%' ";
		} else {
			$where = " WHERE 1=1 ";
		}	
		$public_filter = NULL; $created_filter = NULL;
		$limitstart=$this->getState('limitstart');
		$limit=$this->getState('limit');
		if($limit!=0){
			$limit_cond=" LIMIT ".$limitstart.",".$limit." ";
			if(($limitstart != 0)&&($limitstart < $limit)) { $limit_cond = NULL;}
		} else {
			$limit_cond = NULL;
		}
		
		/* filter by public status - start */
		$public = JRequest::getVar('public');
		if(isset($public)){
			$_SESSION['filter_public']= $public;
			$search_public = $public;
		}
		elseif(isset($_SESSION['filter_public'])) {
			$search_public = $_SESSION['filter_public'];
		}
		if(isset($search_public) && $search_public!='YN' && $search_public != NULL){
			$public_filter.=" AND (c.public='".$search_public."')";
		}
		/* filter by public status - stop */

		/* filter by created_by - start */
		$created_by = JRequest::getVar('created_by');
		if(isset($created_by)){
			$_SESSION['created_by']= $created_by;
			$cfilter = $created_by;
		}
		elseif(isset($_SESSION['created_by'])) {
			$cfilter = $_SESSION['created_by'];
		}
		if(isset($cfilter) && $cfilter != 'YN' && $cfilter != NULL){
			$created_filter.=" AND (c.created_by='".$cfilter."')";
		}
		/* filter by created_by - stop */		
		
		$sql = "SELECT c.*, u.name AS uname, u.username FROM `#__ad_agency_channels` AS c LEFT JOIN `#__users` AS u ON c.created_by = u.id ".$where.$public_filter.$created_filter;
		//echo "<pre>";var_dump($sql);echo "</pre><hr />";
		$this->_total = $this->_getListCount($sql);
		$sql .= " ORDER BY id DESC ".$limit_cond;
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		return $result;
	}
	
	function getChannel() {
		$db = &JFactory::getDBO();
		$data = JRequest::get('post');
		$get = JRequest::get('get');
		
		if(isset($data['cid'][0])&&($data['cid'][0] != 0)) { $current = intval($data['cid'][0]); }
		elseif(isset($get['cid'][0])&&($get['cid'][0] != 0)) { $current = intval($get['cid'][0]); }
				
		if(isset($current)) {
			$sql = "SELECT * FROM `#__ad_agency_channels` WHERE id =".intval($current);
			$db->setQuery($sql); 
			$result = $db->loadObject();
			
			$sql = "SELECT s.type, s.option, s.logical, s.data FROM `#__ad_agency_channels` AS c, `#__ad_agency_channel_set` AS s WHERE c.id = ".$current." AND c.id = s.channel_id ORDER BY s.id ASC";
			$db->setQuery($sql);
			$result->sets = $db->loadObjectList();
			
			//echo "<pre>";var_dump($result);die();
		} else {
			$result = NULL;
		}
		return $result;
	}

	function saveSettings(){
		$db = &JFactory::getDBO();
		$data = JRequest::get('post');
		//echo "<pre>";var_dump($data);echo "<hr>";//die();
		$sql = "UPDATE `#__ad_agency_settings` SET `cityloc` = '".trim($data['cityloc'])."' WHERE `id` > 0;";
		$db->setQuery($sql);
		if(!$db->query()){
			return false;
		}
		$sql = "UPDATE `#__ad_agency_settings` SET `countryloc` = '".trim($data['countryloc'])."' WHERE `id` > 0;";
		$db->setQuery($sql);
		if(!$db->query()){
			return false;
		}
		$sql = "UPDATE `#__ad_agency_settings` SET `codeloc` = '".trim($data['codeloc'])."' WHERE `id` > 0;";
		$db->setQuery($sql);
		if(!$db->query()){
			return false;
		}
		unset($data['codeloc']);
		unset($data['countryloc']);				
		unset($data['cityloc']);
		unset($data['task']);
		unset($data['controller']);
		unset($data['boxchecked']);
		unset($data['option']);
		$data = @serialize($data);
		$sql = "UPDATE `#__ad_agency_settings` SET `geoparams` = '".$data."' WHERE `id` > 0;";
		$db->setQuery($sql);
		if(!$db->query()){
			return false;
		}	
				
		return true;
	}
	
	function getSettings(){
		$db = &JFactory::getDBO();
		$sql = "SELECT geoparams FROM #__ad_agency_settings WHERE id>0 LIMIT 1";
		$db->setQuery($sql);
		$result = $db->loadResult();
		return $result;
	}
	
	function publish(){
		$db = &JFactory::getDBO();
		$data = JRequest::get('post');
		$sql = "UPDATE `#__ad_agency_channels` SET `public` = 'Y' WHERE `id` = '".$data['chan']."' LIMIT 1";
		//echo "<pre>";var_dump($sql);die();
		$db->setQuery($sql);
		if(!$db->query()){
			return false;
		}	
				
		return true;		
	}
	
	function unpublish(){
		$db = &JFactory::getDBO();
		$data = JRequest::get('post');
		$sql = "UPDATE `#__ad_agency_channels` SET `public` = 'N' WHERE `id` = '".$data['chan']."' LIMIT 1";
		//echo "<pre>";var_dump($sql);die();
		$db->setQuery($sql);
		if(!$db->query()){
			return false;
		}	
				
		return true;	
	}
	
	function saveChannel(){
		$db = &JFactory::getDBO();
		$data = JRequest::get('post');				
		$user = &JFactory::getUser();
		
	//	echo "<pre>";var_dump($data);die();
		if (!function_exists('json_encode')) {
			require_once(JPATH_BASE.DS.'components'.DS.'com_adagency'.DS.'helpers'.DS.'jsonwrapper.php');
		}
		
		$when = 'NOW()';
		$created_by = $user->id;
		if(isset($data['cid'][0])&&($data['cid'][0] != 0)) {
			$idToEdit = $data['cid'][0];
			$sql = "SELECT * FROM #__ad_agency_channels WHERE id = '".$idToEdit."'";
			$db->setQuery($sql);
			$chan_info = $db->loadObject();
			//echo "<pre>";var_dump($chan_info);echo "<hr />";//die();
			if(isset($chan_info)&&($chan_info != NULL)){
				$when = "'".$chan_info->created."'";
				if(isset($chan_info->created_by)&&($chan_info->created_by != '')) { $created_by = $chan_info->created_by; }
			}
			$this->delete();
		} else {
			$idToEdit='NULL';
		}
		
		$sql = "INSERT INTO `#__ad_agency_channels` (`id` ,`name`, `banner_id`, `advertiser_id`, `public`, `created`, `created_by`) VALUES (".$idToEdit." , '".$data['cname']."', '".$data['banner_id']."', '".$data['advertiser_id']."', '".$data['public']."', ".$when.", '".$created_by."');";
		//echo "<pre>";var_dump($sql);echo "</pre><hr />";//die();
		$db->setQuery($sql);
		$db->query();
		$sqlz[] = $sql;
		$channel_id = @mysql_insert_id();
		if(!$channel_id) {
			$sql = "SELECT * FROM #__ad_agency_channels WHERE `name` = '".$data['cname']."' ORDER BY id DESC LIMIT 1";
			$sqlz[] = $sql;
			$db->setQuery($sql);
			$channel_id = $db->loadResult();
		}
		
		if(isset($data['limitation'])&&($data['limitation'] != '')) {
			$limitation_sql = "INSERT INTO `#__ad_agency_channel_set` (`id` ,`channel_id` ,`type` ,`logical` ,`option` ,`data`) VALUES ";
			$temp = NULL;
			foreach($data['limitation'] as $element) {
				$temp[] = "( NULL , '".$channel_id."', '".$element['type']."','".$element['logical']."','".$element['option']."', '".json_encode($element['data'])."' )";
			}
			$channel_sets = implode(', ',$temp);
			$sets_sql = $limitation_sql.$channel_sets;
			$sqlz[] = $sets_sql;
			$db->setQuery($sets_sql);
			$db->query();
		}
		//echo "<pre>";var_dump($sqlz);die();
		return $channel_id;
	}

	function checkDuplicate(){
		$db = &JFactory::getDBO();
		$data = JRequest::get('post');	
		$cid = $data['cid'];
			
		if (!function_exists('json_encode')) {
			require_once(JPATH_BASE.DS.'components'.DS.'com_adagency'.DS.'helpers'.DS.'jsonwrapper.php');
		}	
				
		if(isset($data['limitation'])&&($data['limitation'] != '')) {
			$limitation_sql = "INSERT INTO `#__ad_agency_channel_set` (`id` ,`channel_id` ,`type` ,`logical` ,`option` ,`data`) VALUES ";
			$sql = "SELECT s.channel_id FROM #__ad_agency_channel_set AS s, #__ad_agency_channels AS c WHERE s.channel_id = c.id AND c.banner_id =0 ";
			if(isset($cid[0])&&(intval($cid[0])!='0')) {
				$sql.="AND s.channel_id<>".$cid[0]." "; 
				// check for duplicates except for the current channel
			}
			$temp = NULL;
			foreach($data['limitation'] as $element) {
				$extra = "AND (s.type='".$element['type']."' AND s.logical='".$element['logical']."' AND s.option='".$element['option']."' AND s.data='".json_encode($element['data'])."')";
				$sql2 = $sql.$extra;
				$aux[] = $sql2;
				$db->setQuery($sql2);
				$temp[] = $db->loadResultArray();
			}
		}
		if(!empty($temp)){
			$final = NULL;
			if(count($temp)==1) { 
				$final = $temp[0];
			} else {
				for($i=0;$i<=count($temp)-2;$i++){
					$final = array_intersect($temp[$i],$temp[$i+1]);
				}
			}
		}
		
		if(isset($final)&&$final!=NULL){
			foreach($final as $element){
				$sql = "SELECT COUNT(id) FROM #__ad_agency_channel_set WHERE channel_id=".$element;
				$db->setQuery($sql);
				$lim_nr = $db->loadResult();
				echo "<b>".$lim_nr."</b> | ";
				if($lim_nr == count($data['limitation'])) { return false; }
			}
		}
		
		/*echo "<pre>";echo count($data['limitation']);echo "<hr />";
		@var_dump($final);echo "<hr />";
		var_dump($aux);
		die();*/
		
		return true;
	}
	
	function getUIDByAid($id) {
		$db = & JFactory::getDBO();
		$sql = "SELECT user_id FROM #__ad_agency_advertis WHERE aid = '".$id."' LIMIT 1 ";
		$db->setQuery($sql);
		$result = intval($db->loadResult());
		
		$sql = "SELECT username FROM #__users WHERE id = ".$result."";
		$db->setQuery($sql);
		$result2 = $db->loadResult();
		$results = array($result,$result2);
		return $results;
	}	
	
	function getBannerById($id){
		$db = & JFactory::getDBO();
		$sql = "SELECT * FROM #__ad_agency_banners WHERE id = '".$id."' LIMIT 1 ";
		$db->setQuery($sql);
		$result = $db->loadObject();
		return $result;
	}
	
	function delete() {
		$db = &JFactory::getDBO();
		$data = JRequest::get('post');
		$temp = NULL;
		if(isset($data['cid'])) {
			foreach($data['cid'] as $element) {
				$temp[] = $element;
			}
			$in = '('.implode(',',$temp).')';
			$sql1 = 'DELETE FROM #__ad_agency_channels WHERE id IN '.$in;
			$sql2 = 'DELETE FROM #__ad_agency_channel_set WHERE channel_id IN '.$in;
			$db->setQuery($sql1);
			if(!$db->query()) { return false; }
			$db->setQuery($sql2);
			if(!$db->query()) { return false; }
		}
		return true;
	}
};
?>