<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ("joomla.aplication.component.model");

class adagencyAdminModeladagencyPopup extends JModel {
	var $_licenses;
	var $_license;
	var $_id = null;
	var $_total = 0;
	var $_pagination = null;

	function __construct () {
		parent::__construct();
		$cids = JRequest::getVar('cid', 0, '', 'array');
		$this->setId((int)$cids[0]);
		global $mainframe, $option;
		// Get the pagination request variables
		$limit = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );
		$this->setState('limit', $limit); // Set the limit variable for query later on
		$this->setState('limitstart', $limitstart);
	}

	function last_ad($type){
		$db = JFactory::getDBO();
		$sql = "SELECT ID FROM #__ad_agency_banners WHERE media_type='".$type."' GROUP BY id DESC LIMIT 1";
		$db->setQuery($sql);
		return $db->loadResult();
	}

	function getPagination(){
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))	{
			jimport('joomla.html.pagination');
			if (!$this->_total) $this->getListPackages();
			$this->_pagination = new JPagination( $this->_total, $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}

	function setId($id) {
		$this->_tid = $id;
		$this->_package = null;
	}

	function getExistsZone(){
		$db = &JFactory::getDBO();
		$sql = "SELECT zoneid FROM `#__ad_agency_zone` WHERE `adparams` LIKE '%popup%' LIMIT 1";
		$db->setQuery($sql);
		$res = $db->loadResult();
		if(intval($res) > 0) { return true; } else { return false; }
	}

	function getCampsByAid($adv_id, $distinct = 0) {
		$db = JFactory::getDBO();
		$sqls = "
			SELECT c.id, c.name, c.params, z.*
			FROM #__ad_agency_campaign AS c
			JOIN #__ad_agency_order_type AS o
			ON c.otid = o.tid
			JOIN #__ad_agency_package_zone AS pz
			ON pz.package_id = o.tid
			JOIN #__ad_agency_zone AS z
			ON z.zoneid = pz.zone_id
			WHERE c.aid = ".$adv_id." AND z.adparams LIKE '%popup%'
		";
        if ($distinct == 1) { $sqls .= "GROUP BY c.id"; }
        //echo $sqls;die();
		$db->setQuery($sqls);
		$camps = $db->loadObjectList();
        if (is_array($camps))
		foreach($camps as &$element) {
			$element->adparams = @unserialize($element->adparams);
            $element->params = @unserialize($element->params);

            // Select total banners for each campaign
            $sql = "SELECT COUNT( campaign_id )
                       FROM `#__ad_agency_campaign_banner`
                       WHERE `campaign_id` = " . $element->id;
            $db->setQuery($sql);
            $element->totalbanners = $db->loadResult();
		}
		//echo "<pre>";var_dump($camps);die();
		return $camps;
	}

	function processCampZones($camps){
		$zones = array();
		if(isset($camps)&&(is_array($camps))){
			foreach($camps as $camp){
				if(!isset($zones[$camp->id])) { $zones[$camp->id] = $this->getAllZonesForCampByCampId($camps,$camp->id); }
			}
		}
		return $zones;
	}

	function getAllZonesForCampByCampId($camps, $camp_id){
		$resp = array();
		if(isset($camps)&&(is_array($camps))){
			$i = 1;
			foreach($camps as $camp){
				if($camp->id == $camp_id) {
					$resp[$i]['zoneid'] = $camp->zoneid;
					$resp[$i]['z_title'] = $camp->z_title;
					$i++;
				}
			}
		}
		return $resp;
	}

	function createSelectBox($czones,$ad_id){
		$db = &JFactory::getDBO();
		$select = array();
		if(isset($czones)&&(is_array($czones))){
			foreach($czones as $key=>$value){
				$sql = "SELECT zone FROM #__ad_agency_campaign_banner WHERE banner_id = ".$ad_id." AND campaign_id = ".$key;
				$db->setQuery($sql);
				$sel_zone = $db->loadResult();
				$select[$key] = "<select name='czones[".$key."]' id='czones_".$key."' class='w145'>";
				$select[$key] .= "<option value='0'>".JText::_('ADAG_ZONE_FOR_AD')."</option>";
				if(is_array($value)){
					foreach($value as $val){
						if($sel_zone == $val['zoneid']) { $this_selected = " selected='selected' "; } else { $this_selected = NULL; }
						$select[$key] .= "<option value='".$val['zoneid']."' ".$this_selected.">".$val['z_title']."</option>";
					}
				}
				$select[$key] .= "</select>";
			}
		}
		return $select;
	}

	function getlistPackages () {
		if (empty ($this->_packages)) {
			$db = JFactory::getDBO();
			$sql = "select * from #__ad_agency_order_type";
			$this->_total = $this->_getListCount($sql);
			$this->_packages = $this->_getList($sql);
		}
		return $this->_packages;
	}

	function getad() {
		if (empty ($this->_package)) {
			$this->_package =& $this->getTable("adagencyAds");
			$this->_package->load($this->_tid);
			$data = JRequest::get('post');
			if (!$this->_package->bind($data)){
				$this->setError($item->getErrorMsg());
				return false;

			}
			if (!$this->_package->check()) {
				$this->setError($item->getErrorMsg());
				return false;
			}
		}
		return $this->_package;
	}

	function getChannel($bid) {
		$db = &JFactory::getDBO();
		if(isset($bid)) {
			$sql = "SELECT * FROM `#__ad_agency_channels` WHERE banner_id =".intval($bid)." LIMIT 1";
			$db->setQuery($sql);
			$result = $db->loadObject();
			if(!isset($result->id)) { return NULL; }
			$sql = "SELECT s.type, s.option, s.logical, s.data FROM `#__ad_agency_channels` AS c, `#__ad_agency_channel_set` AS s WHERE c.id = ".$result->id." AND c.id = s.channel_id ORDER BY s.id ASC";
			$db->setQuery($sql);
			$result->sets = $db->loadObjectList();

			//echo "<pre>";var_dump($result);die();
		} else {
			$result = NULL;
		}
		return $result;
	}

	function delete_geo($bid, $aid) {
		$db = &JFactory::getDBO();
		$temp = NULL;
		if(isset($bid)&&isset($aid)) {
			$sql0 = 'SELECT id FROM #__ad_agency_channels WHERE banner_id = "'.$bid.'" AND advertiser_id = "'.$aid.'" LIMIT 1';
			$db->setQuery($sql0);
			$id_to_del = $db->loadResult();

			if(isset($id_to_del)&&($id_to_del != NULL)) {
				/*$sql1 = 'DELETE FROM #__ad_agency_channels WHERE id = "'.$id_to_del.'"';
				$db->setQuery($sql1);
				if(!$db->query()) { return false; }*/

				$sql2 = 'DELETE FROM #__ad_agency_channel_set WHERE channel_id = "'.$id_to_del.'"';
				$db->setQuery($sql2);
				if(!$db->query()) { return false; }
			}
		}

		if(isset($id_to_del)) { return $id_to_del; } else { return -1; }
	}

	function getUIDbyAID($aid){
		$db = &JFactory::getDBO();
		$sql = 'SELECT user_id FROM `#__ad_agency_advertis` WHERE aid = "'.$aid.'" LIMIT 1';
		$db->setQuery($sql);
		return $db->loadResult();
	}

	function store_geo($bid = NULL){
		require_once('../components/com_adagency/helpers/channel_fcs.php');
	}

	function store () {
        JLoader::import( 'adagencyads', JPATH_SITE . DS .'components' . DS . 'com_adagency' . DS . 'models' );
        $front_ads_model = JModel::getInstance( 'adagencyAds', 'adagencyModel' );

		global $mainframe;
		$livesite = $mainframe->getSiteURL();
		$database = & JFactory::getDBO();
		$link_label = 'ad_url';
		$item =& $this->getTable('adagencyAds');
		$data = JRequest::get('post');
		$sendmail = $data['sendmail'];
		// Prepare the keywords, trim them
		if(isset($data['keywords'])&&($data['keywords']!='')) {
			$data['keywords'] = implode(',',array_map('trim',explode(',',$data['keywords'])));
		}
		if($data['id']==0){$data['created'] = date("Y-m-d");} else {
			$current_banner = $this->getAdById($data['id']);
		}
		$data['key'] = '';
		$data['width'] = $data['parameters']['window_width'];
		$data['height'] = $data['parameters']['window_height'];
		$row->parameters['show_on'] = "onload";
		$expday = ($data['parameters']['show_ad'] == 0) ? 0*24*60*60*1000 : $data['parameters']["show_ad"]*24*60*60*1000;
		$showon = "window.onload = checkCount;";
		$cookie_name = md5(uniqid(rand(), 1));
		$script = '';
		switch($data['parameters']["popup_type"]) {
				case 'webpage':

				$data['parameters']["preview_script"] = "window.open('".$data['parameters']["page_url"]."', 'popupad', 'width=".$data['parameters']["window_width"].",height=".$data['parameters']["window_height"].",toolbar=".$data['parameters']["toolbar"].",status=".$data['parameters']["status"].",menubar=".$data['parameters']["menubar"].",scrollbars=".$data['parameters']["scrollbars"].",location=no,resizable=".$data['parameters']["resizable"]."');";

					if ($data['parameters']["window_type"] == 'popup') {
$script = <<<EOD
<script language="JavaScript">
var expDays = {$expday};
var page = "{$data['parameters']["page_url"]}";
var windowprops = "width={$data['parameters']["window_width"]},height={$data['parameters']["window_height"]},toolbar={$data['parameters']["toolbar"]},status={$data['parameters']["status"]},menubar={$data['parameters']["menubar"]},scrollbars={$data['parameters']["scrollbars"]},location=no,resizable={$data['parameters']["resizable"]}";
function GetCookie (name) {
	var arg = name + "=";
	var alen = arg.length;
	var clen = document.cookie.length;
	var i = 0;
	while (i < clen) {
		var j = i + alen;
		if (document.cookie.substring(i, j) == arg) return getCookieVal (j);
		i = document.cookie.indexOf(" ", i) + 1;
		if (i == 0) break;
	}
	return null;
}
function SetCookie (name, value) {
	var argv = SetCookie.arguments;
	var argc = SetCookie.arguments.length;
	var expires = (argc > 2) ? argv[2] : null;
	var path = (argc > 3) ? argv[3] : null;
	var domain = (argc > 4) ? argv[4] : null;
	var secure = (argc > 5) ? argv[5] : false;
	document.cookie = name + "=" + escape (value) + ((expires == null) ? "" : ("; expires=" + expires.toGMTString())) + ((path == null) ? "" : ("; path=" + path)) + ((domain == null) ? "" : ("; domain=" + domain)) + ((secure == true) ? "; secure" : "");
}
function DeleteCookie (name) {
	var exp = new Date();
	exp.setTime (exp.getTime() - 1);
	var cval = GetCookie (name);
	document.cookie = name + "=" + cval + "; expires=" + exp.toGMTString();
}
var exp = new Date();
exp.setTime(exp.getTime() + (expDays));
function amt(){
	var count = GetCookie("$cookie_name");
	if(count == null) {
		SetCookie("$cookie_name","1");
		return 1;
	} else {
		var newcount = parseInt(count) + 1;
		DeleteCookie("$cookie_name");
		SetCookie("$cookie_name",newcount,exp);
		return count;
	}
}
function getCookieVal(offset) {
	var endstr = document.cookie.indexOf (";", offset);
	if (endstr == -1) endstr = document.cookie.length;
	return unescape(document.cookie.substring(offset, endstr));
}
function checkCount() {
	var count = GetCookie("$cookie_name");
	if (count == null) {
		count=1;
		SetCookie("$cookie_name", count, exp);
		window.open(page, "popupad", windowprops);
	} else {
		count++;
		SetCookie("$cookie_name", count, exp);
	}
}
{$showon}
</script>
EOD;
					}
					if ($data['parameters']["window_type"] == 'popunder') {
$script = <<<EOD
<script language="JavaScript">
var expDays = {$expday};
var page = "{$data['parameters']["page_url"]}";
var windowprops = "width={$data['parameters']["window_width"]},height={$data['parameters']["window_height"]},toolbar={$data['parameters']["toolbar"]},status={$data['parameters']["status"]},menubar={$data['parameters']["menubar"]},scrollbars={$data['parameters']["scrollbars"]},location=no,resizable={$data['parameters']["resizable"]}";
function GetCookie (name) {
	var arg = name + "=";
	var alen = arg.length;
	var clen = document.cookie.length;
	var i = 0;
	while (i < clen) {
		var j = i + alen;
		if (document.cookie.substring(i, j) == arg) return getCookieVal (j);
		i = document.cookie.indexOf(" ", i) + 1;
		if (i == 0) break;
	}
	return null;
}
function SetCookie (name, value) {
	var argv = SetCookie.arguments;
	var argc = SetCookie.arguments.length;
	var expires = (argc > 2) ? argv[2] : null;
	var path = (argc > 3) ? argv[3] : null;
	var domain = (argc > 4) ? argv[4] : null;
	var secure = (argc > 5) ? argv[5] : false;
	document.cookie = name + "=" + escape (value) + ((expires == null) ? "" : ("; expires=" + expires.toGMTString())) + ((path == null) ? "" : ("; path=" + path)) + ((domain == null) ? "" : ("; domain=" + domain)) + ((secure == true) ? "; secure" : "");
}
function DeleteCookie (name) {
	var exp = new Date();
	exp.setTime (exp.getTime() - 1);
	var cval = GetCookie (name);
	document.cookie = name + "=" + cval + "; expires=" + exp.toGMTString();
}
var exp = new Date();
exp.setTime(exp.getTime() + (expDays));
function amt(){
	var count = GetCookie("$cookie_name");
	if(count == null) {
		SetCookie("$cookie_name","1");
		return 1;
	} else {
		var newcount = parseInt(count) + 1;
		DeleteCookie("$cookie_name");
		SetCookie("$cookie_name",newcount,exp);
		return count;
	}
}
function getCookieVal(offset) {
	var endstr = document.cookie.indexOf (";", offset);
	if (endstr == -1) endstr = document.cookie.length;
	return unescape(document.cookie.substring(offset, endstr));
}
function checkCount() {
	var count = GetCookie("$cookie_name");
	if (count == null) {
		count=1;
		SetCookie("$cookie_name", count, exp);
		window.open(page, "popupad", windowprops).blur();
		window.focus();
	} else {
		count++;
		SetCookie("$cookie_name", count, exp);
	}
}
{$showon}
</script>
EOD;
					}
					break;
				case 'image':
				$mosConfig_live_site = $livesite;
				$data['parameters']['preview_script'] = "var newPopup=window.open('','PopupWindow','width=".$data['parameters']['window_width'].",height=".$data['parameters']['window_height'].",toolbar=".$data['parameters']['toolbar'].",status=".$data['parameters']['status'].",menubar=".$data['parameters']['menubar'].",scrollbars=".$data['parameters']['scrollbars'].",location=no,resizable=".$data['parameters']['resizable']."'); var popContent='<HTML><HEAD><TITLE>Advertisement</TITLE></HEAD><BODY MARGINWIDTH=0 MARGINHEIGHT=0 LEFTMARGIN=0 TOPMARGIN=0 BOTTOMMARGIN=0>';
				popContent+= '<a target=\'_blank\' href=\'{$data["target_url"]}\'><img src=\'{$mosConfig_live_site}/images/stories/ad_agency/{$data["advertiser_id"]}/{$data["image_url"]}\' border=0></a>';
				popContent+='</BODY></HTML>';
				newPopup.document.write(popContent); newPopup.document.close(); newPopup.focus();";

					if ($data['parameters']['window_type'] == 'popup') {
$script = <<<EOD
<script language="javascript">

var expDays = {$expday};
var windowprops = "width={$data['parameters']['window_width']},height={$data['parameters']['window_height']},toolbar={$data['parameters']['toolbar']},status={$data['parameters']['status']},menubar={$data['parameters']['menubar']},scrollbars={$data['parameters']['scrollbars']},location=no,resizable={$data['parameters']['resizable']}";
function GetCookie (name) {
	var arg = name + "=";
	var alen = arg.length;
	var clen = document.cookie.length;
	var i = 0;
	while (i < clen) {
		var j = i + alen;
		if (document.cookie.substring(i, j) == arg) return getCookieVal (j);
		i = document.cookie.indexOf(" ", i) + 1;
		if (i == 0) break;
	}
	return null;
}
function SetCookie (name, value) {
	var argv = SetCookie.arguments;
	var argc = SetCookie.arguments.length;
	var expires = (argc > 2) ? argv[2] : null;
	var path = (argc > 3) ? argv[3] : null;
	var domain = (argc > 4) ? argv[4] : null;
	var secure = (argc > 5) ? argv[5] : false;
	document.cookie = name + "=" + escape (value) + ((expires == null) ? "" : ("; expires=" + expires.toGMTString())) + ((path == null) ? "" : ("; path=" + path)) + ((domain == null) ? "" : ("; domain=" + domain)) + ((secure == true) ? "; secure" : "");
}
function DeleteCookie (name) {
	var exp = new Date();
	exp.setTime (exp.getTime() - 1);
	var cval = GetCookie (name);
	document.cookie = name + "=" + cval + "; expires=" + exp.toGMTString();
}
var exp = new Date();
exp.setTime(exp.getTime() + (expDays));
function amt(){
	var count = GetCookie("$cookie_name");
	if(count == null) {
		SetCookie("$cookie_name","1");
		return 1;
	} else {
		var newcount = parseInt(count) + 1;
		DeleteCookie("$cookie_name");
		SetCookie("$cookie_name",newcount,exp);
		return count;
	}
}
function getCookieVal(offset) {
	var endstr = document.cookie.indexOf (";", offset);
	if (endstr == -1) endstr = document.cookie.length;
	return unescape(document.cookie.substring(offset, endstr));
}
function checkCount() {
	var count = GetCookie("$cookie_name");
	if (count == null) {
		count=1;
		SetCookie("$cookie_name", count, exp);
		var newPopup=window.open("","PopupWindow",windowprops);
		var popContent='<HTML><HEAD><TITLE>Advertisement</TITLE></HEAD><BODY MARGINWIDTH=0 MARGINHEIGHT=0 LEFTMARGIN=0 TOPMARGIN=0 BOTTOMMARGIN=0>';
		popContent+= '<a target="_blank" href="{$link_label}"><img src="{$mosConfig_live_site}/images/stories/ad_agency/{$data["advertiser_id"]}/{$data["image_url"]}" border=0></a>';
		popContent+='</BODY></HTML>';
		newPopup.document.write(popContent);
		newPopup.document.close();
		newPopup.focus();
	} else {
		count++;
		SetCookie("$cookie_name", count, exp);
	}
}
{$showon}
</script>
EOD;
					}
					if ($data['parameters']['window_type'] == 'popunder') {
$script = <<<EOD
<script language="javascript">

var expDays = {$expday};
var windowprops = "width={$data['parameters']['window_width']},height={$data['parameters']['window_height']},toolbar={$data['parameters']['toolbar']},status={$data['parameters']['status']},menubar={$data['parameters']['menubar']},scrollbars={$data['parameters']['scrollbars']},location=no,resizable={$data['parameters']['resizable']}";
function GetCookie (name) {
	var arg = name + "=";
	var alen = arg.length;
	var clen = document.cookie.length;
	var i = 0;
	while (i < clen) {
		var j = i + alen;
		if (document.cookie.substring(i, j) == arg) return getCookieVal (j);
		i = document.cookie.indexOf(" ", i) + 1;
		if (i == 0) break;
	}
	return null;
}
function SetCookie (name, value) {
	var argv = SetCookie.arguments;
	var argc = SetCookie.arguments.length;
	var expires = (argc > 2) ? argv[2] : null;
	var path = (argc > 3) ? argv[3] : null;
	var domain = (argc > 4) ? argv[4] : null;
	var secure = (argc > 5) ? argv[5] : false;
	document.cookie = name + "=" + escape (value) + ((expires == null) ? "" : ("; expires=" + expires.toGMTString())) + ((path == null) ? "" : ("; path=" + path)) + ((domain == null) ? "" : ("; domain=" + domain)) + ((secure == true) ? "; secure" : "");
}
function DeleteCookie (name) {
	var exp = new Date();
	exp.setTime (exp.getTime() - 1);
	var cval = GetCookie (name);
	document.cookie = name + "=" + cval + "; expires=" + exp.toGMTString();
}
var exp = new Date();
exp.setTime(exp.getTime() + (expDays));
function amt(){
	var count = GetCookie("$cookie_name");
	if(count == null) {
		SetCookie("$cookie_name","1");
		return 1;
	} else {
		var newcount = parseInt(count) + 1;
		DeleteCookie("$cookie_name");
		SetCookie("$cookie_name",newcount,exp);
		return count;
	}
}
function getCookieVal(offset) {
	var endstr = document.cookie.indexOf (";", offset);
	if (endstr == -1) endstr = document.cookie.length;
	return unescape(document.cookie.substring(offset, endstr));
}
function checkCount() {
	var count = GetCookie("$cookie_name");
	if (count == null) {
		count=1;
		SetCookie("$cookie_name", count, exp);
		var newPopup=window.open("","PopupWindow",windowprops);
		var popContent='<HTML><HEAD><TITLE>Advertisement</TITLE></HEAD><BODY MARGINWIDTH=0 MARGINHEIGHT=0 LEFTMARGIN=0 TOPMARGIN=0 BOTTOMMARGIN=0>';
		popContent+= '<a target="_blank" href="{$link_label}"><img src="{$mosConfig_live_site}/images/stories/ad_agency/{$data["advertiser_id"]}/{$data["image_url"]}" border=0></a>';
		popContent+='</BODY></HTML>';
		newPopup.document.write(popContent);
		newPopup.document.close();
		newPopup.blur();
	} else {
		count++;
		SetCookie("$cookie_name", count, exp);
	}
}
{$showon}
</script>
EOD;
					}

					break;
				case 'html':
						$crt=1;
						$string='href="';
						$fisier=$data['parameters']["html"];
						$pos1=strpos($fisier,$string);
						while ($pos1) {
							$fisier=substr($fisier,$pos1+strlen($string),strlen($fisier));
							$pos2=strpos($fisier,'"');
							$url=substr($fisier,0,$pos2);
                            if ( $url != 'ad_url' ) {
                                $data['parameters']['linktrack'][$crt] = $url;
                                $pos1 = false;
                            } elseif (isset($data['id'])) {
                                $sql = "SELECT parameters FROM #__ad_agency_banners WHERE id = " . $data['id'];
                                $database->setQuery($sql);
                                $tmp_params = $database->loadResult();
                                $tmp_params = @unserialize($tmp_params);
                                if ( isset($tmp_params['linktrack'][1]) ) {
                                    $url = $tmp_params['linktrack'][1];
                                    $data['parameters']['linktrack'][1] = $url;
                                }
                                $pos1 = false;
                            }
							//$crt++;
							$pos1=strpos($fisier,$string);
						}

					$html_content = "";
					$data['parameters']["html"] = preg_replace("/href((\s+)?)=((\s+)?)\"\b((http(s?):\/\/)|(www\.)|(ftp:\/\/))([\w\.]+)([-~\/\w+\.-?]+)\b/i","href=\"ad_url",$data['parameters']['html']);
					$LINES = explode("\n", $data['parameters']["html"]);
					foreach ($LINES as $i=>$v) {
						$v = trim($v);
						$html_content .= "popContent+='".$v."\\r\\n';\r\n";
					}

					$preview_content = "";
					$LINES = explode("\n", addslashes($data['parameters']["html"]));
					foreach ($LINES as $i=>$v) {
						$v = trim($v);
						$preview_content .= "popContent+='".$v."\\r\\n';\r\n";
					}

					$data['parameters']['preview_script'] = "var newPopup=window.open('','PopupWindow','width=".$data['parameters']['window_width'].",height=".$data['parameters']['window_height'].",toolbar=".$data['parameters']['toolbar'].",status=".$data['parameters']['status'].",menubar=".$data['parameters']['menubar'].",scrollbars=".$data['parameters']['scrollbars'].",location=no,resizable=".$data['parameters']['resizable']."');
					var popContent='<HTML><HEAD><TITLE>Advertisement</TITLE></HEAD><BODY MARGINWIDTH=0 MARGINHEIGHT=0 LEFTMARGIN=0 TOPMARGIN=0 BOTTOMMARGIN=0>'; ".$preview_content." popContent+='</BODY></HTML>';
					newPopup.document.write(popContent); newPopup.document.close(); newPopup.focus(); ";

					if ($data['parameters']['window_type'] == 'popup') {
$script = <<<EOD
<script language="javascript">
var expDays = {$expday};
var windowprops = "width={$data['parameters']['window_width']},height={$data['parameters']['window_height']},toolbar={$data['parameters']['toolbar']},status={$data['parameters']['status']},menubar={$data['parameters']['menubar']},scrollbars={$data['parameters']['scrollbars']},location=no,resizable={$data['parameters']['resizable']}";
function GetCookie (name) {
	var arg = name + "=";
	var alen = arg.length;
	var clen = document.cookie.length;
	var i = 0;
	while (i < clen) {
		var j = i + alen;
		if (document.cookie.substring(i, j) == arg) return getCookieVal (j);
		i = document.cookie.indexOf(" ", i) + 1;
		if (i == 0) break;
	}
	return null;
}
function SetCookie (name, value) {
	var argv = SetCookie.arguments;
	var argc = SetCookie.arguments.length;
	var expires = (argc > 2) ? argv[2] : null;
	var path = (argc > 3) ? argv[3] : null;
	var domain = (argc > 4) ? argv[4] : null;
	var secure = (argc > 5) ? argv[5] : false;
	document.cookie = name + "=" + escape (value) + ((expires == null) ? "" : ("; expires=" + expires.toGMTString())) + ((path == null) ? "" : ("; path=" + path)) + ((domain == null) ? "" : ("; domain=" + domain)) + ((secure == true) ? "; secure" : "");
}
function DeleteCookie (name) {
	var exp = new Date();
	exp.setTime (exp.getTime() - 1);
	var cval = GetCookie (name);

	document.cookie = name + "=" + cval + "; expires=" + exp.toGMTString();
}
var exp = new Date();
exp.setTime(exp.getTime() + (expDays));
function amt(){
	var count = GetCookie("$cookie_name");
	if(count == null) {
		SetCookie("$cookie_name","1");
		return 1;
	} else {
		var newcount = parseInt(count) + 1;
		DeleteCookie("$cookie_name");
		SetCookie("$cookie_name",newcount,exp);
		return count;
	}
}
function getCookieVal(offset) {
	var endstr = document.cookie.indexOf (";", offset);
	if (endstr == -1) endstr = document.cookie.length;
	return unescape(document.cookie.substring(offset, endstr));
}
function checkCount() {
	var count = GetCookie("$cookie_name");
	if (count == null) {
		count=1;
		SetCookie("$cookie_name", count, exp);
		var newPopup=window.open("","PopupWindow",windowprops);
		var popContent='<HTML><HEAD><TITLE>Advertisement</TITLE></HEAD><BODY MARGINWIDTH=0 MARGINHEIGHT=0 LEFTMARGIN=0 TOPMARGIN=0 BOTTOMMARGIN=0>';

		{$html_content}

		popContent+='</BODY></HTML>';
		newPopup.document.write(popContent);
		newPopup.document.close();
		newPopup.focus();
	} else {
		count++;
		SetCookie("$cookie_name", count, exp);
	}
}
{$showon}
</script>
EOD;
					}
					if ($data['parameters']['window_type'] == 'popunder') {
$script = <<<EOD
<script language="javascript">
var expDays = {$expday};

var windowprops = "width={$data['parameters']['window_width']},height={$data['parameters']['window_height']},toolbar={$data['parameters']['toolbar']},status={$data['parameters']['status']},menubar={$data['parameters']['menubar']},scrollbars={$data['parameters']['scrollbars']},location=no,resizable={$data['parameters']['resizable']}";
function GetCookie (name) {
	var arg = name + "=";
	var alen = arg.length;
	var clen = document.cookie.length;
	var i = 0;
	while (i < clen) {
		var j = i + alen;
		if (document.cookie.substring(i, j) == arg) return getCookieVal (j);
		i = document.cookie.indexOf(" ", i) + 1;
		if (i == 0) break;
	}
	return null;
}
function SetCookie (name, value) {
	var argv = SetCookie.arguments;
	var argc = SetCookie.arguments.length;
	var expires = (argc > 2) ? argv[2] : null;
	var path = (argc > 3) ? argv[3] : null;
	var domain = (argc > 4) ? argv[4] : null;
	var secure = (argc > 5) ? argv[5] : false;
	document.cookie = name + "=" + escape (value) + ((expires == null) ? "" : ("; expires=" + expires.toGMTString())) + ((path == null) ? "" : ("; path=" + path)) + ((domain == null) ? "" : ("; domain=" + domain)) + ((secure == true) ? "; secure" : "");
}
function DeleteCookie (name) {
	var exp = new Date();
	exp.setTime (exp.getTime() - 1);
	var cval = GetCookie (name);
	document.cookie = name + "=" + cval + "; expires=" + exp.toGMTString();
}
var exp = new Date();
exp.setTime(exp.getTime() + (expDays));
function amt(){
	var count = GetCookie("$cookie_name");
	if(count == null) {
		SetCookie("$cookie_name","1");
		return 1;
	} else {
		var newcount = parseInt(count) + 1;
		DeleteCookie("$cookie_name");
		SetCookie("$cookie_name",newcount,exp);
		return count;
	}
}
function getCookieVal(offset) {
	var endstr = document.cookie.indexOf (";", offset);
	if (endstr == -1) endstr = document.cookie.length;
	return unescape(document.cookie.substring(offset, endstr));
}
function checkCount() {
	var count = GetCookie("$cookie_name");
	if (count == null) {
		count=1;
		SetCookie("$cookie_name", count, exp);
		var newPopup=window.open("","PopupWindow",windowprops);
		var popContent='<HTML><HEAD><TITLE>Advertisement</TITLE></HEAD><BODY MARGINWIDTH=0 MARGINHEIGHT=0 LEFTMARGIN=0 TOPMARGIN=0 BOTTOMMARGIN=0>';

		{$html_content}

		popContent+='</BODY></HTML>';
		newPopup.document.write(popContent);
		newPopup.document.close();
		newPopup.blur();
	} else {
		count++;
		SetCookie("$cookie_name", count, exp);
	}
}
{$showon}
</script>
EOD;
					}
					break;
				default:
					break;
			}

	$content = $script;

	if ($data['parameters']['popup_type']!="image") {
		$data['width'] = $data['parameters']['window_width'];
		$data['height'] = $data['parameters']['window_height'];
	}



		$data['parameters'] = serialize($data['parameters']);

		//$data['location'] = json_encode($data['limitation']);

		if (!$item->bind($data)){
			$this->setError($item->getErrorMsg());
			return false;

		}

		if (!$item->check()) {
			$this->setError($item->getErrorMsg());
			return false;

		}

		if (!$item->store()) {
			$this->setError($item->getErrorMsg());
			return false;

		}


		$configs = $this->getInstance("adagencyConfig", "adagencyAdminModel");
		$configs = $configs->getConfigs();
		$cids = intval($_POST['id']);
		$db = & JFactory::getDBO();

		if (isset($_POST['id']) && ($_POST['id']!=0)) $where = $_POST['id'];
			else $where = mysql_insert_id();
		if ($where==0) {
			$ask = "SELECT `id` FROM `#__ad_agency_banners` ORDER BY `id` DESC LIMIT 1 ";
			$db->setQuery( $ask );
			$where = $db->loadResult();
		}

		if(isset($where)) {
			$this->store_geo($where);
		}

		$sql = "DELETE FROM #__ad_agency_campaign_banner WHERE banner_id = '".$where."'";
		$db->setQuery($sql);
		$db->query();

        $campLimInfo = $front_ads_model->getCampLimInfo($data['advertiser_id']);

		if(isset($data['adv_cmp'])) {
			foreach ($data['adv_cmp'] as $val) {
                if ( ($val) && (
                    ( !isset($campLimInfo[$val])) || ( $campLimInfo[$val]['adslim'] > $campLimInfo[$val]['occurences'] )
                ) ) {
                	$query = "INSERT INTO `#__ad_agency_campaign_banner` (`campaign_id` ,`banner_id` ,`relative_weighting` ,`thumb`, `zone`) VALUES ('".$val."', '".$where."', '100', NULL, ".$data['czones'][$val].");";
					//$query = "INSERT INTO #__ad_agency_campaign_banner VALUES ({$val},{$where},100)";
					$db->setQuery($query);
					$db->query();
				}
			}
		}

		$sql = "UPDATE #__ad_agency_banners SET `ad_code` = '".$db->getEscaped($content)."' WHERE `id`='".$where."'";
		$db->setQuery($sql);
		$db->query();

		if(($sendmail)&&(isset($current_banner)&&($current_banner->approved!=$data['approved'])&&($data['approved']!='P'))) {
			$this->sendmail($current_banner->id,$data['approved']);
		}

		return $item->id;

	}

	function getAdById($id){
		$db = & JFactory::getDBO();
		$sql = "SELECT * FROM #__ad_agency_banners WHERE id =".$id;
		$db->setQuery($sql);
		$result = $db->loadObject();
		return $result;
	}

	function sendmail ($cid,$task) {
		$db =& JFactory::getDBO();
		$configs = $this->getInstance("adagencyConfig", "adagencyAdminModel");
		$configs = $configs->getConfigs();
		$item =& $this->getTable('adagencyAds');

		//send email notifications
			$sql = "SELECT b.title, u.name, u.username, u.email FROM #__ad_agency_banners AS b LEFT JOIN #__ad_agency_advertis as a ON a.aid=b.advertiser_id LEFT JOIN #__users as u ON u.id=a.user_id WHERE b.id = '".$cid."' GROUP BY b.id";
			$db->setQuery($sql);
			if(!$result = $db->query()) {
				echo $db->stderr();
				return;
			}
			$user = $db->loadObjectList();
	        foreach ( $user as $value) {

				if($task == 'Y') {
					$subject=$configs->sbadappv;
					$message=$configs->bodyadappv;
				} else {
					$subject=$configs->sbaddisap;
					$message=$configs->bodyaddisap;
				}

				$subject =str_replace('{name}',$value->name,$subject);
				$subject =str_replace('{login}',$value->username,$subject);
				$subject =str_replace('{email}',$value->email,$subject);
				$subject =str_replace('{banner}',$value->title,$subject);
				$message =str_replace('{name}',$value->name,$message);
				$message =str_replace('{login}',$value->username,$message);
				$message =str_replace('{email}',$value->email,$message);
				$message =str_replace('{banner}',$value->title,$message);
				// mail publish campaign
				JUtility::sendMail( $configs->fromemail, $configs->fromname, $value->email, $subject, $message, 1 );
			}
		//send email notifications
		return 1;
	}

	function delete () {
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$item =& $this->getTable('adagencyPackage');
		foreach ($cids as $cid) {
			if (!$item->delete($cid)) {
				$this->setError($item->getErrorMsg());
				return false;

			}
		}

		return true;
	}


	function publish () {
		$db =& JFactory::getDBO();
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$task = JRequest::getVar('task', '', 'post');
		$item =& $this->getTable('adagencyPackage');
		if ($task == 'publish')
			$sql = "update #__ad_agency_order_type set published='1' where tid in ('".implode("','", $cids)."')";

		$db->setQuery($sql);
		if (!$db->query() ){
			$this->setError($db->getErrorMsg());
			return false;
		}
		return 1;
	}

	function unpublish () {
		$db =& JFactory::getDBO();
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$task = JRequest::getVar('task', '', 'post');
		$item =& $this->getTable('adagencyPackage');
		if ($task == 'unpublish')
			$sql = "update #__ad_agency_order_type set published='0' where tid in ('".implode("','", $cids)."')";

		$db->setQuery($sql);
		if (!$db->query() ){
			$this->setError($db->getErrorMsg());
			return false;
		}
		return -1;
	}

	function getpopuplistAdvertisers () {
		if (empty ($this->_package)) {
			$db =& JFactory::getDBO();
			$sql = "SELECT a.aid, b.name as company, a.user_id FROM #__ad_agency_advertis as a, #__users as b WHERE a.user_id = b.id ORDER BY company ASC";
			$db->setQuery($sql);
			if (!$db->query()) {
				echo $db->stderr();
				return;
			}
			$this->_package = $db->loadObjectList();

		}
		return $this->_package;

	}

};
?>
