<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ("joomla.aplication.component.model");
require_once('components/com_adagency/helpers/class.upload.php');

class adagencyAdminModeladagencyTextlink extends JModel {
	var $_licenses;
	var $_license;
	var $_id = null;
	var $_total = 0;
	var $_pagination = null;

	function __construct () {
		parent::__construct();
		$cids = JRequest::getVar('cid', 0, '', 'array');
		$this->setId((int)$cids[0]);
		global $mainframe, $option;
		// Get the pagination request variables
		$limit = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );
		$this->setState('limit', $limit); // Set the limit variable for query later on
		$this->setState('limitstart', $limitstart);
	}

	function setId($id) {
		$this->_id = $id;
		$this->_license = null;
	}

	function getPagination(){
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))	{
			jimport('joomla.html.pagination');
			if (!$this->_total) $this->getListAds();
			$this->_pagination = new JPagination( $this->_total, $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}

	function getExistsZone(){
		$db = &JFactory::getDBO();
		$sql = "SELECT zoneid FROM `#__ad_agency_zone` WHERE `adparams` LIKE '%textad%' LIMIT 1";
		$db->setQuery($sql);
		$res = $db->loadResult();
		if(intval($res) > 0) { return true; } else { return false; }
	}

	function getlistAds () {
		if (empty ($this->_licenses)) {
			$sql = "SELECT a.aid AS advertiser_id2, a.company AS advertiser, concat(width,'x',height) AS size_type,
			b.*,
			m.id mid, m.title zone_name
			FROM #__ad_agency_banners AS b
			LEFT OUTER JOIN #__ad_agency_advertis AS a on b.advertiser_id = a.aid
			LEFT JOIN #__ad_agency_campaign_banner AS cb ON cb.banner_id = b.id
			LEFT JOIN #__modules AS m ON m.id=b.zone
			WHERE 1=1
			GROUP BY b.id
			ORDER BY b.id DESC
			";
		$this->_licenses = $this->_getList($sql);
		$rows = $this->_licenses;
		$ids = array();
		foreach($rows as $row)
			array_push($ids, $row->id);
		$ids = implode(",", $ids);

		if ($ids == "") $ids = "null";
		$sql2 = <<<eosql
select
			banner_id,
			sum(case s.type when 'impressions' then s.how_many else 0 end) as impressions,
			sum(case s.type when 'click' then s.how_many else 0 end) as click,
			TRUNCATE((sum(case s.type when 'click' then s.how_many else 0 end)/(sum(case s.type when 'impressions' then s.how_many else 0 end)/100)),2) as click_rate
			FROM #__ad_agency_stat s
where banner_id in($ids)
group by banner_id
eosql;
		$this->_licenses = $this->_getList($sql2);
		$rows2 = $this->_licenses;
		foreach($rows2 as $row2)
			foreach($rows as $k=>$row)
				if($row2->banner_id == $row->id)
				{
					$rows[$k]->impressions = $row2->impressions;
					$rows[$k]->click = $row2->click;
					$rows[$k]->click_rate = $row2->click_rate;
					$sqlz	= "SELECT count(c.id) FROM #__ad_agency_campaign c INNER JOIN #__ad_agency_campaign_banner cb ON c.id = cb.campaign_id WHERE banner_id = {$row->id}";
					$this->_licenses = $this->_getList($sqlz);

				}
			$this->_licenses = $rows;
		}

		return $this->_licenses;
	}

	function getad() {
		if (empty ($this->_package)) {
			$this->_package =& $this->getTable("adagencyAds");
			$this->_package->load($this->_id);
			$data = JRequest::get('post');
			if (!$this->_package->bind($data)){
				$this->setError($item->getErrorMsg());
				return false;

			}
			if (!$this->_package->check()) {
				$this->setError($item->getErrorMsg());
				return false;
			}
		}
		return $this->_package;
	}

	function getCampsByAid($adv_id, $distinct = 0) {
		$db = JFactory::getDBO();
		$sqls = "
			SELECT c.id, c.name, c.params, z.*
			FROM #__ad_agency_campaign AS c
			JOIN #__ad_agency_order_type AS o
			ON c.otid = o.tid
			JOIN #__ad_agency_package_zone AS pz
			ON pz.package_id = o.tid
			JOIN #__ad_agency_zone AS z
			ON z.zoneid = pz.zone_id
			WHERE c.aid = ".$adv_id." AND z.adparams LIKE '%textad%'
		";
        if ($distinct == 1) { $sqls .= "GROUP BY c.id"; }
        //echo $sqls;die();
		$db->setQuery($sqls);
		$camps = $db->loadObjectList();
        if (is_array($camps))
		foreach($camps as &$element) {
			$element->adparams = @unserialize($element->adparams);
            $element->params = @unserialize($element->params);

            // Select total banners for each campaign
            $sql = "SELECT COUNT( campaign_id )
                       FROM `#__ad_agency_campaign_banner`
                       WHERE `campaign_id` = " . $element->id;
            $db->setQuery($sql);
            $element->totalbanners = $db->loadResult();
		}
		//echo "<pre>";var_dump($camps);die();
		return $camps;
	}

	function processCampZones($camps){
		$zones = array();
		if(isset($camps)&&(is_array($camps))){
			foreach($camps as $camp){
				if(!isset($zones[$camp->id])) { $zones[$camp->id] = $this->getAllZonesForCampByCampId($camps,$camp->id); }
			}
		}
		return $zones;
	}

	function getAllZonesForCampByCampId($camps, $camp_id){
		$resp = array();
		if(isset($camps)&&(is_array($camps))){
			$i = 1;
			foreach($camps as $camp){
				if($camp->id == $camp_id) {
					$resp[$i]['zoneid'] = $camp->zoneid;
					$resp[$i]['z_title'] = $camp->z_title;
					$i++;
				}
			}
		}
		return $resp;
	}

	function createSelectBox($czones,$ad_id){
		$db = &JFactory::getDBO();
		$select = array();
		if(isset($czones)&&(is_array($czones))){
			foreach($czones as $key=>$value){
				$sql = "SELECT zone FROM #__ad_agency_campaign_banner WHERE banner_id = ".$ad_id." AND campaign_id = ".$key;
				$db->setQuery($sql);
				$sel_zone = $db->loadResult();
				$select[$key] = "<select name='czones[".$key."]' id='czones_".$key."' class='w145'>";
				$select[$key] .= "<option value='0'>".JText::_('ADAG_ZONE_FOR_AD')."</option>";
				if(is_array($value)){
					foreach($value as $val){
						if($sel_zone == $val['zoneid']) { $this_selected = " selected='selected' "; } else { $this_selected = NULL; }
						$select[$key] .= "<option value='".$val['zoneid']."' ".$this_selected.">".$val['z_title']."</option>";
					}
				}
				$select[$key] .= "</select>";
			}
		}
		return $select;
	}

	function getAltsAd($id){
		$db =  &JFactory::getDBO();
		$sql = "SELECT parameters FROM #__ad_agency_banners WHERE id = '".$id."'";
		$db->setQuery($sql);
		$res = $db->loadResult();
		$params = @unserialize($res);
		return $params;
	}

	function last_ad($type){
		$db = JFactory::getDBO();
		$sql = "select id from #__ad_agency_banners WHERE media_type='".$type."' GROUP BY id DESC LIMIT 1";
		$db->setQuery($sql);
		return $db->loadResult();
	}

	function getChannel($bid) {
		$db = &JFactory::getDBO();
		if(isset($bid)) {
			$sql = "SELECT * FROM `#__ad_agency_channels` WHERE banner_id =".intval($bid)." LIMIT 1";
			$db->setQuery($sql);
			$result = $db->loadObject();
			if(!isset($result->id)) { return NULL; }
			$sql = "SELECT s.type, s.option, s.logical, s.data FROM `#__ad_agency_channels` AS c, `#__ad_agency_channel_set` AS s WHERE c.id = ".$result->id." AND c.id = s.channel_id ORDER BY s.id ASC";
			$db->setQuery($sql);
			$result->sets = $db->loadObjectList();

			//echo "<pre>";var_dump($result);die();
		} else {
			$result = NULL;
		}
		return $result;
	}

	function delete_geo($bid, $aid) {
		$db = &JFactory::getDBO();
		$temp = NULL;
		if(isset($bid)&&isset($aid)) {
			$sql0 = 'SELECT id FROM #__ad_agency_channels WHERE banner_id = "'.$bid.'" AND advertiser_id = "'.$aid.'" LIMIT 1';
			$db->setQuery($sql0);
			$id_to_del = $db->loadResult();

			if(isset($id_to_del)&&($id_to_del != NULL)) {
				/*$sql1 = 'DELETE FROM #__ad_agency_channels WHERE id = "'.$id_to_del.'"';
				$db->setQuery($sql1);
				if(!$db->query()) { return false; }*/

				$sql2 = 'DELETE FROM #__ad_agency_channel_set WHERE channel_id = "'.$id_to_del.'"';
				$db->setQuery($sql2);
				if(!$db->query()) { return false; }
			}
		}

		if(isset($id_to_del)) { return $id_to_del; } else { return -1; }
	}

	function getUIDbyAID($aid){
		$db = &JFactory::getDBO();
		$sql = 'SELECT user_id FROM `#__ad_agency_advertis` WHERE aid = "'.$aid.'" LIMIT 1';
		$db->setQuery($sql);
		return $db->loadResult();
	}

	function store_geo($bid = NULL){
		require_once('../components/com_adagency/helpers/channel_fcs.php');
	}

	function store () {
        JLoader::import( 'adagencyads', JPATH_SITE . DS .'components' . DS . 'com_adagency' . DS . 'models' );
        $front_ads_model = JModel::getInstance( 'adagencyAds', 'adagencyModel' );
        $database = & JFactory::getDBO();
		$item =& $this->getTable('adagencyAds');
		$data = JRequest::get('post');
		$sendmail = $data['sendmail'];
		$data['key'] = '';
		// Prepare the keywords, trim them
		if(isset($data['keywords'])&&($data['keywords']!='')) {
			$data['keywords'] = implode(',',array_map('trim',explode(',',$data['keywords'])));
		}
		if($data['id']==0){$data['created'] = date("Y-m-d");} else {
			$current_banner = $this->getAdById($data['id']);
		}
		//echo "<pre>";var_dump($data['parameters']);die();
		//$paramz = $data['parameters'];
		$data['parameters'] = serialize($data['parameters']);
		$res = true;
		if (!$item->bind($data)){
			$res = false;
		}
		if (!$item->check()) {
			$res = false;
		}
		if (!$item->store()) {
			$res = false;
		}
		$configs = $this->getInstance("adagencyConfig", "adagencyAdminModel");
		$configs = $configs->getConfigs();
		$cids = intval($_POST['id']);
		$db = & JFactory::getDBO();

		if (!isset($data['id']) || $data['id']==0) $data['id'] = mysql_insert_id();
		$idi = $data['id'];
		if ($idi==0) {
			$ask = "SELECT `id` FROM `#__ad_agency_banners` ORDER BY `id` DESC LIMIT 1 ";
			$db->setQuery( $ask );
			$idi = $db->loadResult();
		}

		if(isset($idi)) {
			$this->store_geo($idi);
		}

		$sql = "DELETE FROM #__ad_agency_campaign_banner WHERE banner_id = '".$idi."'";
		$db->setQuery($sql);
		$db->query();

		$JPATH_BASE = str_replace('administrator','',JPATH_BASE);

		if(isset($data['image_url'])&&($data['image_url'] != NULL)) {
			$img_url = $JPATH_BASE.'images'.DS.'stories'.DS.$configs->imgfolder.DS.$data['advertiser_id'].DS.$data['image_url'];
			@list($width_orig, $height_orig, $type, $attr) = @getimagesize($img_url);
		}

/*		echo "<pre>";
		echo "JPATH_BASE: ".JPATH_BASE."<br />";
		echo "(dollar)JPATH_BASE: ".$JPATH_BASE."<br />";
		echo "DS: ".DS."<br />";
		echo "img_url: ".$img_url."<br />";
		echo "</pre>";
		die();
*/
		$campLimInfo = $front_ads_model->getCampLimInfo($data['advertiser_id']);

		if(isset($data['adv_cmp'])) {
			foreach ($data['adv_cmp'] as $val) {
                if ( ($val) && (
                    ( !isset($campLimInfo[$val])) || ( $campLimInfo[$val]['adslim'] > $campLimInfo[$val]['occurences'] )
                ) ) {
					$query = "INSERT INTO `#__ad_agency_campaign_banner` (`campaign_id` ,`banner_id` ,`relative_weighting` ,`thumb`, `zone`) VALUES ('".$val."', '".$idi."', '100', NULL, ".$data['czones'][$val].");";
					$db->setQuery($query);
					$db->query();

					$query = "SELECT z.adparams,z.textadparams FROM #__ad_agency_zone AS z WHERE z.zoneid = ".$data['czones'][$val];
					$db->setQuery($query);
					$res = $db->loadObject();
					$zparams = @unserialize($res->adparams);
					$paramz = @unserialize($res->textadparams);

					if(isset($paramz['mxsize'])&&(intval($paramz['mxsize'])>0)&&(isset($paramz['mxtype']))) {
						if((($paramz['mxtype'] == 'w')&&($paramz['mxsize'] < $zparams['width']))||($zparams['width'] == '')){
							//$ratio = $zparams['width']/$zparams['height'];$zparams['height'] = $zparams['width']/$ratio;
							$zparams['width'] = $paramz['mxsize'];
						} elseif((($paramz['mxtype'] == 'h')&&($paramz['mxsize'] < $zparams['height']))||($zparams['height'] == '')){
							//$ratio = $zparams['width']/$zparams['height'];$zparams['width'] = $ratio * $zparams['height'];
							$zparams['height'] = $paramz['mxsize'];
						}
					}

					if(isset($zparams['width']) && isset($zparams['height']) && ($width_orig != NULL) && isset($width_orig) && isset($height_orig) && (($width_orig > $zparams['width'])||($height_orig > $zparams['height'])) ) {
						// make the thumb with the maximum size or the zone

						//echo "<pre>";var_dump($zparams);echo "<br />*** Cid: ".$val."</pre><hr />";
						$thumb = $this->makeThumb($img_url, $zparams['width'], $zparams['height']);
						if(($thumb != NULL)&&($thumb != false)) {
							$sql = "UPDATE `#__ad_agency_campaign_banner` SET `thumb` = '".$thumb."' WHERE `campaign_id` =".$val." AND `banner_id` =".$idi.";";
						} else {
							$sql = "UPDATE `#__ad_agency_campaign_banner` SET `thumb` = NULL WHERE `campaign_id` =".$val." AND `banner_id` =".$idi.";";
						}
						$db->setQuery($sql);
						$db->query();

						$fls[] = $thumb;
					}

				}
			}
		}

		//echo "<pre>";var_dump($fls);die();

		if(($sendmail)&&(isset($current_banner)&&($current_banner->approved!=$data['approved'])&&($data['approved']!='P'))) {
			$this->sendmail($current_banner->id,$data['approved']);
		}

		//echo "<pre>";var_dump($fls);die();

		return $res;

	}

	function makeThumb($file_url, $width, $height){
		$handle = new Upload($file_url);

		list($width_orig, $height_orig) = @getimagesize($file_url);
		if(!isset($width_orig)||($width_orig == NULL)) { return false; }
		$ratio_orig = $width_orig/$height_orig;
		if($width == '') { $width = $height*$ratio_orig; }
		elseif($height == '') { $height = $width/$ratio_orig; }

		if ($width/$height > $ratio_orig) {
		   $width = $height*$ratio_orig;
		} else {
		   $height = $width/$ratio_orig;
		}

		$check['width'] = (int)$width;
		$check['height'] = (int)$height;
		if(($check['width'] == 0)&&($check['height'] == 0)){
			return NULL;
		}

		$width = number_format($width,0);
		$height = number_format($height,0);

		$pieces = explode(DS,$file_url);
		$filename = explode('.',$pieces[count($pieces)-1]);
		$pieces[count($pieces)-1] = '';
		$pieces = implode(DS,$pieces);
		$dir_dest = $pieces;

		if ($handle->uploaded) {
			$handle->image_resize			= true;
			$handle->image_x				= $width;
			$handle->image_y				= $height;
			$handle->file_new_name_body		= $filename[0].'_w'.$width.'_h'.$height;
			$handle->file_overwrite			= true;
			$handle->jpeg_quality 			= 100;

			$handle->Process($dir_dest);
			if ($handle->processed) {
				return $handle->file_dst_name;
			}  else {
				return false;
			}
		} else {
			return false;
		}
	}

	function getPrevZones(){
		$db =& JFactory::getDBO();
		$sql = "SELECT zoneid, z_title, textadparams FROM `#__ad_agency_zone` WHERE `adparams` LIKE '%textad%'";
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		//echo "<pre>";var_dump($result);die();
		return $result;
	}

	function getAdById($id){
		$db = & JFactory::getDBO();
		$sql = "SELECT * FROM #__ad_agency_banners WHERE id =".$id;
		$db->setQuery($sql);
		$result = $db->loadObject();
		return $result;
	}

	function sendmail ($cid,$task) {
		$db =& JFactory::getDBO();
		$configs = $this->getInstance("adagencyConfig", "adagencyAdminModel");
		$configs = $configs->getConfigs();
		$item =& $this->getTable('adagencyAds');

		//send email notifications
			$sql = "SELECT b.title, u.name, u.username, u.email FROM #__ad_agency_banners AS b LEFT JOIN #__ad_agency_advertis as a ON a.aid=b.advertiser_id LEFT JOIN #__users as u ON u.id=a.user_id WHERE b.id = '".$cid."' GROUP BY b.id";
			$db->setQuery($sql);
			if(!$result = $db->query()) {
				echo $db->stderr();
				return;
			}
			$user = $db->loadObjectList();
	        foreach ( $user as $value) {

				if($task == 'Y') {
					$subject=$configs->sbadappv;
					$message=$configs->bodyadappv;
				} else {
					$subject=$configs->sbaddisap;
					$message=$configs->bodyaddisap;
				}

				$subject =str_replace('{name}',$value->name,$subject);
				$subject =str_replace('{login}',$value->username,$subject);
				$subject =str_replace('{email}',$value->email,$subject);
				$subject =str_replace('{banner}',$value->title,$subject);
				$message =str_replace('{name}',$value->name,$message);
				$message =str_replace('{login}',$value->username,$message);
				$message =str_replace('{email}',$value->email,$message);
				$message =str_replace('{banner}',$value->title,$message);
				// mail publish campaign
				JUtility::sendMail( $configs->fromemail, $configs->fromname, $value->email, $subject, $message, 1 );
			}
		//send email notifications
		return 1;
	}

	function delete () {
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$item =& $this->getTable('adagencyLicense');
		foreach ($cids as $cid) {
			if (!$item->delete($cid)) {
				$this->setError($item->getErrorMsg());
				return false;

			}
		}
		return true;
	}

	function publish () {
		$db =& JFactory::getDBO();
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$task = JRequest::getVar('task', '', 'post');
		$item =& $this->getTable('adagencyLicense');
		if ($task == 'publish'){
			$sql = "update #__adagency_licenses set published='1' where id in ('".implode("','", $cids)."')";
		} else {
			$sql = "update #__adagency_licenses set published='0' where id in ('".implode("','", $cids)."')";

		}
		$db->setQuery($sql);
		if (!$db->query() ){
			$this->setError($db->getErrorMsg());
			return false;
		}
	}

	function gettextlistAdvertisers () {
		if (empty ($this->_package)) {
			$db =& JFactory::getDBO();
			$sql = "SELECT a.aid, b.name as company, a.user_id FROM #__ad_agency_advertis as a, #__users as b WHERE a.user_id = b.id ORDER BY company ASC";
			$db->setQuery($sql);
			if (!$db->query()) {
				echo $db->stderr();
				return;
			}
			$this->_package = $db->loadObjectList();
		}
		return $this->_package;
	}

};
?>
