<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ("joomla.aplication.component.model");

class adagencyAdminModeladagencyTransition extends JModel {
	var $_licenses;
	var $_license;
	var $_id = null;
	var $_total = 0;
	var $_pagination = null;

	function __construct () {
		parent::__construct();
		$cids = JRequest::getVar('cid', 0, '', 'array');

		$this->setId((int)$cids[0]);
		global $mainframe, $option;
		// Get the pagination request variables
		$limit = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );
		$this->setState('limit', $limit); // Set the limit variable for query later on
		$this->setState('limitstart', $limitstart);
	}

	function getPagination(){
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))	{
			jimport('joomla.html.pagination');
			if (!$this->_total) $this->getListPackages();
			$this->_pagination = new JPagination( $this->_total, $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}

	function setId($id) {
		$this->_tid = $id;
		$this->_package = null;
	}

	function getlistPackages () {
		if (empty ($this->_packages)) {
			$db = JFactory::getDBO();
			$sql = "select * from #__ad_agency_order_type";
			$this->_total = $this->_getListCount($sql);
			$this->_packages = $this->_getList($sql);
		}
		return $this->_packages;
	}

	function getExistsZone(){
		$db = &JFactory::getDBO();
		$sql = "SELECT zoneid FROM `#__ad_agency_zone` WHERE `adparams` LIKE '%transition%' LIMIT 1";
		$db->setQuery($sql);
		$res = $db->loadResult();
		if(intval($res) > 0) { return true; } else { return false; }
	}

	function getCampsByAid($adv_id, $distinct = 0) {
		$db = JFactory::getDBO();
		$sqls = "
			SELECT c.id, c.name, c.params, z.*
			FROM #__ad_agency_campaign AS c
			JOIN #__ad_agency_order_type AS o
			ON c.otid = o.tid
			JOIN #__ad_agency_package_zone AS pz
			ON pz.package_id = o.tid
			JOIN #__ad_agency_zone AS z
			ON z.zoneid = pz.zone_id
			WHERE c.aid = ".$adv_id." AND z.adparams LIKE '%transition%'
		";
        if ($distinct == 1) { $sqls .= "GROUP BY c.id"; }
        //echo $sqls;die();
		$db->setQuery($sqls);
		$camps = $db->loadObjectList();
        if (is_array($camps))
		foreach($camps as &$element) {
			$element->adparams = @unserialize($element->adparams);
            $element->params = @unserialize($element->params);

            // Select total banners for each campaign
            $sql = "SELECT COUNT( campaign_id )
                       FROM `#__ad_agency_campaign_banner`
                       WHERE `campaign_id` = " . $element->id;
            $db->setQuery($sql);
            $element->totalbanners = $db->loadResult();
		}
		//echo "<pre>";var_dump($camps);die();
		return $camps;
	}

	function processCampZones($camps){
		$zones = array();
		if(isset($camps)&&(is_array($camps))){
			foreach($camps as $camp){
				if(!isset($zones[$camp->id])) { $zones[$camp->id] = $this->getAllZonesForCampByCampId($camps,$camp->id); }
			}
		}
		return $zones;
	}

	function getAllZonesForCampByCampId($camps, $camp_id){
		$resp = array();
		if(isset($camps)&&(is_array($camps))){
			$i = 1;
			foreach($camps as $camp){
				if($camp->id == $camp_id) {
					$resp[$i]['zoneid'] = $camp->zoneid;
					$resp[$i]['z_title'] = $camp->z_title;
					$i++;
				}
			}
		}
		return $resp;
	}

	function createSelectBox($czones,$ad_id){
		$db = &JFactory::getDBO();
		$select = array();
		if(isset($czones)&&(is_array($czones))){
			foreach($czones as $key=>$value){
				$sql = "SELECT zone FROM #__ad_agency_campaign_banner WHERE banner_id = ".$ad_id." AND campaign_id = ".$key;
				$db->setQuery($sql);
				$sel_zone = $db->loadResult();
				$select[$key] = "<select name='czones[".$key."]' id='czones_".$key."' class='w145'>";
				$select[$key] .= "<option value='0'>".JText::_('ADAG_ZONE_FOR_AD')."</option>";
				if(is_array($value)){
					foreach($value as $val){
						if($sel_zone == $val['zoneid']) { $this_selected = " selected='selected' "; } else { $this_selected = NULL; }
						$select[$key] .= "<option value='".$val['zoneid']."' ".$this_selected.">".$val['z_title']."</option>";
					}
				}
				$select[$key] .= "</select>";
			}
		}
		return $select;
	}

	function last_ad($type){
		$db = JFactory::getDBO();
		$sql = "select id from #__ad_agency_banners WHERE media_type='".$type."' GROUP BY id DESC LIMIT 1";
		$db->setQuery($sql);
		return $db->loadResult();
	}

	function getad() {
		if (empty ($this->_package)) {
			$this->_package =& $this->getTable("adagencyAds");
			$this->_package->load($this->_tid);
			$data = JRequest::get('post');
			if (!$this->_package->bind($data)){
				$this->setError($item->getErrorMsg());
				return false;
			}
			if (!$this->_package->check()) {
				$this->setError($item->getErrorMsg());
				return false;
			}
		}
		return $this->_package;
	}

	function getChannel($bid) {
		$db = &JFactory::getDBO();
		if(isset($bid)) {
			$sql = "SELECT * FROM `#__ad_agency_channels` WHERE banner_id =".intval($bid)." LIMIT 1";
			$db->setQuery($sql);
			$result = $db->loadObject();
			if(!isset($result->id)) { return NULL; }
			$sql = "SELECT s.type, s.option, s.logical, s.data FROM `#__ad_agency_channels` AS c, `#__ad_agency_channel_set` AS s WHERE c.id = ".$result->id." AND c.id = s.channel_id ORDER BY s.id ASC";
			$db->setQuery($sql);
			$result->sets = $db->loadObjectList();

			//echo "<pre>";var_dump($result);die();
		} else {
			$result = NULL;
		}
		return $result;
	}

	function delete_geo($bid, $aid) {
		$db = &JFactory::getDBO();
		$temp = NULL;
		if(isset($bid)&&isset($aid)) {
			$sql0 = 'SELECT id FROM #__ad_agency_channels WHERE banner_id = "'.$bid.'" AND advertiser_id = "'.$aid.'" LIMIT 1';
			$db->setQuery($sql0);
			$id_to_del = $db->loadResult();

			if(isset($id_to_del)&&($id_to_del != NULL)) {
				/*$sql1 = 'DELETE FROM #__ad_agency_channels WHERE id = "'.$id_to_del.'"';
				$db->setQuery($sql1);
				if(!$db->query()) { return false; }*/

				$sql2 = 'DELETE FROM #__ad_agency_channel_set WHERE channel_id = "'.$id_to_del.'"';
				$db->setQuery($sql2);
				if(!$db->query()) { return false; }
			}
		}

		if(isset($id_to_del)) { return $id_to_del; } else { return -1; }
	}

	function getUIDbyAID($aid){
		$db = &JFactory::getDBO();
		$sql = 'SELECT user_id FROM `#__ad_agency_advertis` WHERE aid = "'.$aid.'" LIMIT 1';
		$db->setQuery($sql);
		return $db->loadResult();
	}

	function store_geo($bid = NULL){
		require_once('../components/com_adagency/helpers/channel_fcs.php');
	}

	function store () {
        JLoader::import( 'adagencyads', JPATH_SITE . DS .'components' . DS . 'com_adagency' . DS . 'models' );
        $front_ads_model = JModel::getInstance( 'adagencyAds', 'adagencyModel' );
		$database = & JFactory::getDBO();
		$item =& $this->getTable('adagencyAds');
		$_POST["parameters"]["ad_code"] = $_POST['transitioncode'];
		$data = JRequest::get('post');
		$sendmail = $data['sendmail'];
		$data['key'] = '';
		// Prepare the keywords, trim them
		if(isset($data['keywords'])&&($data['keywords']!='')) {
			$data['keywords'] = implode(',',array_map('trim',explode(',',$data['keywords'])));
		}
		if($data['id']==0){$data['created'] = date("Y-m-d");} else {
			$current_banner = $this->getAdById($data['id']);
		}
		$data['parameters']["ad_code"] = $_POST['transitioncode'];
		/*saving transition ad*/
			$crt=1;
			$string='href="';
			$fisier=$data['parameters']["ad_code"];
			$pos1=strpos($fisier,$string);
			while ($pos1) {
				$fisier=substr($fisier,$pos1+strlen($string),strlen($fisier));
				$pos2=strpos($fisier,'"');
				$url=substr($fisier,0,$pos2);
				$data['parameters']["linktrack"][$crt] = $url;
				$crt++;
				$pos1=strpos($fisier,$string);
			}
		$bordercolor = $data['parameters']["border_color"];
		$backcolor = $data['parameters']["bg_color"];
		$html_content = preg_replace("/(href((\s+)?)=((\s+)?)\")\b((http(s?):\/\/)|(www\.)|(ftp:\/\/))([\w\.]+)([-~\/\w+\.-?\&\,\%\=]+)\b/i","href=\"ad_url",$data['parameters']["ad_code"]);

$closead = "Close Ad";
		$script = <<<EOD
<script type="text/javascript">
function getAbsoluteLeft(objectId) {
	// Get an object left position from the upper left viewport corner
	// Tested with relative and nested objects
	o = document.getElementById(objectId);
	oLeft = o.offsetLeft;           // Get left position from the parent object
	while(o.offsetParent!=null) {   // Parse the parent hierarchy up to the document element
		oParent = o.offsetParent;    // Get parent object reference
		oLeft += oParent.offsetLeft; // Add parent left position
		o = oParent;
	}
	// Return left postion
	return oLeft;
}

function getAbsoluteTop(objectId) {
	// Get an object top position from the upper left viewport corner
	// Tested with relative and nested objects
	o = document.getElementById(objectId);
	oTop = o.offsetTop;            // Get top position from the parent object
	while(o.offsetParent!=null) { // Parse the parent hierarchy up to the document element
		oParent = o.offsetParent;  // Get parent object reference
		oTop += oParent.offsetTop; // Add parent top position
		o = oParent;
	}
	// Return top position
	return oTop;
}

function leftposition() {
	var left=getAbsoluteLeft("floatvert");
	document.getElementById("floatvert").style.left = (-1) * left + "px";
}

function topposition() {
	var top = getAbsoluteTop("floatvert");
	document.getElementById("floatvert").style.top = (-1) * top + "px";
}
function initbox(){
	document.getElementById("floatvert").style.visibility="visible";
	if (!document.all) {
	asd = document.getElementById("floatvert");
	asd.parentNode.removeChild(asd);
	document.body.appendChild(asd); }
	leftposition();
	topposition();
}
function HideVert() {
    document.getElementById("floatvert").style.visibility="hidden";
}
var screenWidth = screen.width;
var screenHeight = screen.height;
</script>
<div id="floatvert" style="z-index:1000;position:absolute;top:1px;left:1px;visibility:hidden; background-color: #{$backcolor}; border-color: #{$bordercolor};">
<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" id="continut2">
<tr>
	<td bordercolor="{$bordercolor}" bgcolor="{$backcolor}"align="{$data['parameters']["align"]}" id="containing_td" valign="{$data['parameters']["valign"]}">
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" id="continut3">
		<tr>
			<td align="left" valign="top">
				<table border="{$data['parameters']["border"]}" cellpadding="5" cellspacing="0" style="border-collapse: collapse" id="continut4" >
				<tr>
					<td align="left">
						<a href="" onClick="HideVert();return false;">{$closead}</a>
					</td>
				</tr>
				<tr>
					<td id="continut" valign="top" >

					{$html_content}

				        </td>
				</tr>
				</table>
			</td>
		</tr>
		</table>
	</td>
</tr>

</table>
<script type="text/javascript">
initbox();
document.getElementById("continut").width = screen.width;
document.getElementById("continut").height = screen.height;
document.getElementById("continut2").width = screen.width;
document.getElementById("continut2").height = screen.height;
document.getElementById("continut3").width = screen.width;
document.getElementById("continut3").height = screen.height;
document.getElementById("continut4").width = screen.width;
document.getElementById("continut4").height = screen.height;
</script>
</div>
EOD;
	$adcodu = $script;


		$data['parameters'] = serialize($data['parameters']);
		//$data['location'] = json_encode($data['limitation']);

		if (!$item->bind($data)){
			$this->setError($item->getErrorMsg());
			return false;

		}

		if (!$item->check()) {
			$this->setError($item->getErrorMsg());
			return false;

		}

		if (!$item->store()) {
			$this->setError($item->getErrorMsg());
			return false;

		}


		$configs = $this->getInstance("adagencyConfig", "adagencyAdminModel");
		$configs = $configs->getConfigs();
		$cids = intval($_POST['id']);
		$db = & JFactory::getDBO();

		if (isset($_POST['id']) && ($_POST['id']!=0)) $where = $_POST['id'];
			else $where = mysql_insert_id();
		if ($where==0) {
			$ask = "SELECT `id` FROM `#__ad_agency_banners` ORDER BY `id` DESC LIMIT 1 ";
			$db->setQuery( $ask );
			$where = $db->loadResult();
		}

		if(isset($where)) {
			$this->store_geo($where);
		}

		$sql = "DELETE FROM #__ad_agency_campaign_banner WHERE banner_id = '".$where."'";
		$db->setQuery($sql);
		$db->query();

        $campLimInfo = $front_ads_model->getCampLimInfo($data['advertiser_id']);

		if(isset($data['adv_cmp'])) {
			foreach ($data['adv_cmp'] as $val) {
                if ( ($val) && (
                    ( !isset($campLimInfo[$val])) || ( $campLimInfo[$val]['adslim'] > $campLimInfo[$val]['occurences'] )
                ) ) {
                	$query = "INSERT INTO `#__ad_agency_campaign_banner` (`campaign_id` ,`banner_id` ,`relative_weighting` ,`thumb`, `zone`) VALUES ('".$val."', '".$where."', '100', NULL, ".$data['czones'][$val].");";
					//$query = "INSERT INTO #__ad_agency_campaign_banner VALUES ({$val},{$where},100)";
					$db->setQuery($query);
					$db->query();
				}
			}
		}

		$sql = "UPDATE #__ad_agency_banners SET `ad_code` = '".$db->getEscaped($adcodu)."' WHERE `id`='".$where."'";
		$db = JFactory::getDBO();
		$db->setQuery($sql);
		$db->query();

		if(($sendmail)&&(isset($current_banner)&&($current_banner->approved!=$data['approved'])&&($data['approved']!='P'))) {
			$this->sendmail($current_banner->id,$data['approved']);
		}

		return true;

	}

	function getAdById($id){
		$db = & JFactory::getDBO();
		$sql = "SELECT * FROM #__ad_agency_banners WHERE id =".$id;
		$db->setQuery($sql);
		$result = $db->loadObject();
		return $result;
	}

	function sendmail ($cid,$task) {
		$db =& JFactory::getDBO();
		$configs = $this->getInstance("adagencyConfig", "adagencyAdminModel");
		$configs = $configs->getConfigs();
		$item =& $this->getTable('adagencyAds');

		//send email notifications
			$sql = "SELECT b.title, u.name, u.username, u.email FROM #__ad_agency_banners AS b LEFT JOIN #__ad_agency_advertis as a ON a.aid=b.advertiser_id LEFT JOIN #__users as u ON u.id=a.user_id WHERE b.id = '".$cid."' GROUP BY b.id";
			$db->setQuery($sql);
			if(!$result = $db->query()) {
				echo $db->stderr();
				return;
			}
			$user = $db->loadObjectList();
	        foreach ( $user as $value) {

				if($task == 'Y') {
					$subject=$configs->sbadappv;
					$message=$configs->bodyadappv;
				} else {
					$subject=$configs->sbaddisap;
					$message=$configs->bodyaddisap;
				}

				$subject =str_replace('{name}',$value->name,$subject);
				$subject =str_replace('{login}',$value->username,$subject);
				$subject =str_replace('{email}',$value->email,$subject);
				$subject =str_replace('{banner}',$value->title,$subject);
				$message =str_replace('{name}',$value->name,$message);
				$message =str_replace('{login}',$value->username,$message);
				$message =str_replace('{email}',$value->email,$message);
				$message =str_replace('{banner}',$value->title,$message);
				// mail publish campaign
				JUtility::sendMail( $configs->fromemail, $configs->fromname, $value->email, $subject, $message, 1 );
			}
		//send email notifications
		return 1;
	}

	function delete () {
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$item =& $this->getTable('adagencyPackage');
		foreach ($cids as $cid) {
			if (!$item->delete($cid)) {
				$this->setError($item->getErrorMsg());
				return false;

			}
		}

		return true;
	}


	function publish () {
		$db =& JFactory::getDBO();
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$task = JRequest::getVar('task', '', 'post');
		$item =& $this->getTable('adagencyPackage');
		if ($task == 'publish')
			$sql = "update #__ad_agency_order_type set published='1' where tid in ('".implode("','", $cids)."')";

		$db->setQuery($sql);
		if (!$db->query() ){
			$this->setError($db->getErrorMsg());
			return false;
		}
		return 1;
	}

	function unpublish () {
		$db =& JFactory::getDBO();
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$task = JRequest::getVar('task', '', 'post');
		$item =& $this->getTable('adagencyPackage');
		if ($task == 'unpublish')
			$sql = "update #__ad_agency_order_type set published='0' where tid in ('".implode("','", $cids)."')";

		$db->setQuery($sql);
		if (!$db->query() ){
			$this->setError($db->getErrorMsg());
			return false;
		}
		return -1;
	}

	function gettransitionlistAdvertisers () {
		if (empty ($this->_package)) {
			$db =& JFactory::getDBO();
			$sql = "SELECT a.aid, b.name as company, a.user_id FROM #__ad_agency_advertis as a, #__users as b WHERE a.user_id = b.id ORDER BY company ASC";
			$db->setQuery($sql);
			if (!$db->query()) {
				echo $db->stderr();
				return;
			}
			$this->_package = $db->loadObjectList();

		}
		return $this->_package;

	}

};
?>
