<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ("joomla.aplication.component.model");
require_once('components/com_adagency/helpers/class.upload.php');

class adagencyAdminModeladagencyZone extends JModel {
	var $_promos;
	var $_promo;
	var $_id = null;

	function __construct () {
		parent::__construct();
		$cids = JRequest::getVar('cid', 0, '', 'array');
		$this->setId((int)$cids[0]);
		global $mainframe, $option;
		// Get the pagination request variables
		$limit = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );
		$this->setState('limit', $limit); // Set the limit variable for query later on
		$this->setState('limitstart', $limitstart);
	}

	function getPagination(){
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))	{
			jimport('joomla.html.pagination');
			if (!$this->_total) $this->getlistZones();
			$this->_pagination = new JPagination( $this->_total, $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}

	function setId($id) {
		$this->_id = $id;
		$this->_promo = null;
	}

	function getApprovedAds(){
		$db =& JFactory::getDBO();
		$sql="SELECT id,title FROM `#__ad_agency_banners` WHERE approved='Y'";
		$db->setQuery($sql);
		$result=$db->loadObjectList();
		return $result;
	}

	function getZoneById($id){
		$db =& JFactory::getDBO();
		$sql="SELECT z.*, m.published FROM `#__ad_agency_zone` AS z, `#__modules` AS m WHERE zoneid='".$id."' AND z.zoneid = m.id LIMIT 1";
		$db->setQuery($sql);
		$result=$db->loadObjectList();
		return $result;
	}

	function getLastZoneId(){
		$db =& JFactory::getDBO();
		$sql="SELECT zoneid FROM `#__ad_agency_zone` ORDER BY zoneid DESC LIMIT 1";
		$db->setQuery($sql);
		$result=$db->loadResult();
		return $result;
	}

	function duplicate(){
		$db =& JFactory::getDBO();
		foreach ($_POST['cid'] as $element){
			$item =& $this->getTable('adagencyZone');
			$modul =& $this->getTable('adagencyModules');
			// Saving the module - begin
			$current = $this->getZoneById($element);
			$data = $current[0];
			$data->z_title.=" copy";
			$data->title=$data->z_title;
			$data->zoneid=NULL;
			$data->showtitle=$data->show_title;
			$data->params=$data->suffix;
			$data->module = 'mod_ijoomla_adagency_zone';
			$data->published = 0;
			$data->position = $data->z_position;
			$zone = $data;
			//var_dump($data);

			if (!$modul->bind($data)){
				$this->setError($modul->getErrorMsg());
				return false;
			}

			if (!$modul->check()) {
				$this->setError($modul->getErrorMsg());
				return false;
			}

			if (!$modul->store()) {
				$this->setError($modul->getErrorMsg());
				return false;
			}

			// Saving the module - End

			// Saving the zone - Begin
			$zone->zoneid = mysql_insert_id();
			if ($zone->zoneid==0) {
				$ask = "SELECT `id` FROM `#__modules` ORDER BY `id` DESC LIMIT 1 ";
				$db->setQuery( $ask );
				$zone->zoneid = $db->loadResult();
			}

			$query = "INSERT INTO #__ad_agency_zone ( `zoneid` , `banners` , `banners_cols`, `z_title` , `z_ordering` , `z_position` , `show_title` , `suffix`, `rotatebanners`, `rotaterandomize`, `rotating_time`, `show_adv_link`, `link_taketo`, `taketo_url`, `cellpadding`) VALUES ({$zone->zoneid}, {$zone->banners}, {$zone->banners_cols}, '{$zone->z_title}', {$zone->z_ordering}, '{$zone->z_position}', {$zone->showtitle}, '{$zone->suffix}', '{$zone->rotatebanners}', '{$zone->rotaterandomize}', '{$zone->rotating_time}', '{$zone->show_adv_link}', '{$zone->link_taketo}', '{$zone->taketo_url}', '{$zone->cellpadding}')";
			$db->setQuery($query);
			$db->query();
			// Saving the zone - End

			// Saving the menu assignment - Begin
			$query = "SELECT menuid FROM `#__modules_menu` WHERE `moduleid` = ".$element;
			$db->setQuery($query);
			$results = $db->loadResultArray();

			$cond = NULL;
			foreach ($results as $key){
				$cond[].="('".$zone->zoneid."','{$key}')";
			}
			$cond = implode(", ",$cond);
			$query = "INSERT INTO `#__modules_menu` (`moduleid` ,`menuid`) VALUES ".$cond.";";
			$db->setQuery($query);
			$db->query();
			// Saving the menu assignment - End

			//	Saving the wildcard packages also - Begin
			$query = "SELECT tid, zones_wildcard FROM `#__ad_agency_order_type` WHERE
			`zones_wildcard` LIKE '%|".$element."' OR
			`zones_wildcard` LIKE '%|".$element."|%' OR
			`zones_wildcard` LIKE '".$element."|%' OR
			`zones_wildcard`='".$element."' ";
			$db->setQuery($query);
			$wildcard_list = $db->loadObjectList();

			if(isset($wildcard_list)){
				foreach ($wildcard_list as $current){
					$sql="UPDATE `#__ad_agency_order_type` SET `zones_wildcard` = '".$current->zones_wildcard."|".$zone->zoneid."' WHERE `tid` =".$current->tid.";";
					$db->setQuery($sql);
					$db->query();
				}
			}
			$data = NULL;
			//echo "<pre>";var_dump($wildcard_list);die();

			//	Saving the wildcard packages also - End
		}
		return true;
	}

	function getlistZones () {
		if (empty ($this->_promos)) {
		$and_filter="";
		$limit_cond=NULL;
		$db = &JFactory::getDBO();

		/* search by zone(module) name - start */
		$P_search_zone=JRequest::getVar('search_zone');
		if(isset($P_search_zone))
		{
			$_SESSION['search_zone'] = $db->getEscaped($P_search_zone);
			$search_zone = $db->getEscaped($P_search_zone);
		}
		elseif(isset($_SESSION['search_zone']))
			$search_zone = $db->getEscaped($_SESSION['search_zone']);
		if(isset($search_zone) && $search_zone!=''){
			$and_filter.=" AND (m.title LIKE '%".$search_zone."%' OR m.id LIKE '%".$search_zone."%')"; }
		/* search by zone(module) name - stop */

		/* search by zone(module) position - start */
		$P_module_position=JRequest::getVar('module_position');
		if(isset($P_module_position)){
			$_SESSION['module_position']=$db->getEscaped($P_module_position);
			$search_position=$db->getEscaped($P_module_position);
		}
		else
			if(isset($_SESSION['module_position']))
				$search_position=$db->getEscaped($_SESSION['module_position']);
		if (isset($search_position) && $search_position!='' && $search_position!='0' && $search_position!= trim(JText::_('AD_ZONES_ALL_POS')) ){
			$and_filter.=" AND (m.position='" . trim($search_position) ."')";
		}
		/* search by zone(module) position - stop */
			$where[] = "m.module='mod_ijoomla_adagency_zone'";
			$sql ="SELECT m.*, MIN(mm.menuid) AS pages, z.*
                      FROM #__modules AS m
                      LEFT JOIN #__modules_menu AS mm
                      ON mm.moduleid = m.id
                      LEFT JOIN #__ad_agency_zone AS z
                      ON z.zoneid = m.id
                      WHERE m.module='mod_ijoomla_adagency_zone'
                      ".$and_filter."
                      GROUP BY m.id ORDER BY m.id ASC";

			$limitstart=$this->getState('limitstart');
			$limit=$this->getState('limit');

			if($limit!=0){
				$limit_cond=" LIMIT ".$limitstart.",".$limit." ";
			}

			$this->_total = $this->_getListCount($sql);
			$this->_promos = $this->_getList($sql.$limit_cond);
		}
		return $this->_promos;
	}

	function getZone() {
		if (empty ($this->_promo)) {
			$this->_promo =& $this->getTable("adagencyZone");
			$this->_promo->load($this->_id);
		}
		return $this->_promo;
	}

	function cleanup() {
		$db = & JFactory::getDBO();
		$sql = "SELECT id FROM `#__modules` WHERE module = 'mod_ijoomla_adagency_zone' AND id NOT IN
				(SELECT zoneid FROM `#__ad_agency_zone`) ORDER BY id DESC";
		$db->setQuery($sql);
		$res = $db->loadResultArray();
		$res[count($res)] = '0';
		$cond = implode(',',$res);
		//echo "<pre>";var_dump($cond);die();
		$sql = "DELETE FROM `#__modules` WHERE id IN (".$cond.")";
		$db->setQuery($sql);
		$db->query();
		return true;
	}


	function getTheModule($moduleid) {
		if (empty ($this->_module)) {
			$sql = "SELECT * FROM #__modules WHERE id ='".$moduleid."'";
			$this->_module = $this->_getList($sql);
		}
		return $this->_module;
	}

	function getZonePacks2Select($param){
		if (empty ($this->_selpack)) {
			$sql = "SELECT tid,description,zones_wildcard FROM #__ad_agency_order_type WHERE zones NOT LIKE '%".$param."%' AND zones NOT LIKE '%All Zones%'";
			$this->_selpack = $this->_getList($sql);
		}
		return $this->_selpack;
	}

	function getZonePacks2SelectALL(){
		if (empty ($this->_selpack)) {
			$sql = "SELECT tid,description,zones_wildcard FROM #__ad_agency_order_type";
			$this->_selpack = $this->_getList($sql);
		}
		return $this->_selpack;
	}

	function getThePositions($clientid) {
		if (empty ($this->_position)) {
			$db =& JFactory::getDBO();
			// extracting the positions from template - start
			$query = 'SELECT template'.
				' FROM #__templates_menu' .
				' WHERE client_id=0';
			// ADAGENCYONEFIVE-97 - stop
			$db->setQuery( $query );
			$templateDir = $db->loadResult();

			$client		=& JApplicationHelper::getClientInfo(JRequest::getVar('client', '0', '', 'int'));
			$tBaseDir	= JPath::clean($client->path.DS.'templates');

			if(!is_file($tBaseDir.DS.$templateDir.DS.'templateDetails.xml')) {
				return false;
			}

			$xml = & JFactory::getXMLParser('Simple');

			if (!$xml->loadFile($tBaseDir.DS.$templateDir.DS.'templateDetails.xml')) {
				unset($xml);
				return false;
			}

			$element_array = & $xml->document->positions[0]->_children;
			if(isset($element_array))
			foreach($element_array as $element)
				$xml_positions[] = $element->_data;

			// ADAGENCYONEFIVE-97 - start
			// displaying all positions regardless the client_id
			$query = 'SELECT DISTINCT(position)'.
				' FROM #__modules' .
				' WHERE 1 = 1 ORDER BY position ASC';
			// ADAGENCYONEFIVE-97 - stop
			$db->setQuery( $query );
			$db_positions = $db->loadResultArray();

			$all_positions = $xml_positions;
			if(isset($db_positions))
			foreach($db_positions as $one_position)
				if(@!in_array($one_position, $all_positions))
					$all_positions[] = $one_position;

			sort($all_positions);

			$this->_position = $all_positions;
			$this->_position = (is_array($this->_position)) ? $this->_position : array();
		}
		return $this->_position;
	}

	function getLockZone($zoneid){
		$db = &JFactory::getDBO();
        $sql = "SELECT COUNT(cb.campaign_id)
                FROM #__ad_agency_package_zone AS pz
                JOIN #__ad_agency_campaign AS c ON pz.package_id = c.otid
                JOIN #__ad_agency_campaign_banner AS cb ON c.id = cb.campaign_id
                JOIN #__ad_agency_banners AS b ON cb.banner_id = b.id
                WHERE cb.zone = pz.zone_id AND pz.zone_id =" . intval($zoneid);
		$db->setQuery($sql);
		$existing = $db->loadResult();
		if($existing > 0) { return true; }
		else { return false; }
	}

	function store () {
		$db =& JFactory::getDBO();
		$item =& $this->getTable('adagencyZone');
		$modul =& $this->getTable('adagencyModules');
		$data = JRequest::get('post');
		// echo "<pre>";var_dump($data);die();

        // if the zone is new remember that
        if ( !isset($data['zoneid']) || ($data['zoneid'] <= 0) ) {
            $isNew = TRUE;
        } else {
            $isNew = FALSE;
        }

		// Determine wheather there was a change
		// to the text ad maximum width/height setting
		$trigger_thumb_resize = false;
		if(isset($data['zoneid']) && ($data['zoneid'] != 0) && isset($data['textadparams'])) {
			$sql = "SELECT textadparams FROM #__ad_agency_zone WHERE zoneid = ".$data['zoneid'];
			$db->setQuery($sql);
			$old_tsettings = @unserialize($db->loadResult());
			if(!isset($old_tsettings->mxsize) || !isset($old_tsettings->mxtype) ||
				($old_tsettings->mxsize != $data['textadparams']['mxsize']) || ($old_tsettings->mxtype != $data['textadparams']['mxtype'])) {
				$trigger_thumb_resize = true;

				if(!isset($data['adparams']['width']) || ($data['adparams']['width'] == '') || ($data['adparams']['width'] == 0)) {
					$ad_w = $data['textadparams']['mxsize'];
				} else { $ad_w = $data['adparams']['width']; }
				if(!isset($data['adparams']['height']) || ($data['adparams']['height'] == '') || ($data['adparams']['height'] == 0)) {
					$ad_h = $data['textadparams']['mxsize'];
				} else { $ad_h = $data['textadparams']['mxsize']; }

				if($data['textadparams']['mxtype'] == 'w') {
					$new_width = min($data['textadparams']['mxsize'], $ad_w);
					$new_height = '';
				} else {
					$new_width = '';
					$new_height = min($data['textadparams']['mxsize'], $ad_h);
				}
			}
		}

		//echo "width: ".$new_width."<br /> height: ".$new_height;die();

		if(isset($data['bx'])&&($data['bx']=='2')) { $data['adparams']['textad']= '1'; }
		if(isset($data['adparams']['width']) && isset($data['adparams']['height'])){
			$data['textadparams']['width'] = $data['adparams']['width'];
			$data['textadparams']['height'] = $data['adparams']['height'];
		}
		$data['adparams'] = @serialize($data['adparams']);

		$zona = array();
		$zona['z_title'] = $data['title'];
		$zona['banners'] = $data['banners'];
		$zona['banners_cols'] = $data['banners_cols'];
		if (isset($data['zoneid'])) $zona['zoneid'] = $data['zoneid'];
		$zona['showtitle'] = $data['showtitle'];
		$zona['z_ordering'] = $data['ordering'];
		$zona['z_position'] = $data['position'];

		$zona['rotatebanners'] = $data['rotatebanners'];
		$zona['rotaterandomize'] = $data['rotaterandomize'];
		$zona['rotating_time'] = $data['rotating_time'];
		$zona['defaultad'] = $data['defaultad'];

		$zona['show_adv_link'] = $data['show_adv_link'];
		$zona['link_taketo'] = $data['link_taketo'];
		$zona['cellpadding'] = $data['cellpadding'];
		$zona['adparams'] = $data['adparams'];
		$zona['keywords'] = $data['keywords'];
		$zona['ignorestyle'] = $data['ignorestyle'];
		$zona['textadparams'] = @serialize($data['textadparams']);

		if(isset($data['taketo_url']))
			$zona['taketo_url'] = $data['taketo_url'];
		else
			$zona['taketo_url'] = 'http://';

		$zona['suffix'] = 'moduleclass_sfx='.$data['params'];
		$data['params'] = $zona['suffix'];
		if (isset($data['zoneid'])) {
			$data['id'] = $data['zoneid'];
			$zonid = $data['zoneid'];
		}
		$data['module'] = 'mod_ijoomla_adagency_zone';

		if (!$modul->bind($data)){
			$this->setError($modul->getErrorMsg());
			return false;
		}

		if (!$modul->check()) {
			$this->setError($modul->getErrorMsg());
			return false;
		}

		if (!$modul->store()) {
			$this->setError($modul->getErrorMsg());
			return false;
		}
		if ($zona['zoneid']=="") {
			$zona['zoneid'] = mysql_insert_id();
			if ($zona['zoneid']==0) {
				$ask = "SELECT `id` FROM `#__modules` ORDER BY `id` DESC LIMIT 1 ";
				$db->setQuery( $ask );
				$zona['zoneid'] = $db->loadResult();
			}
			if(!isset($zona['z_ordering'])) { $zona['z_ordering'] = 0; }
			$query = "INSERT INTO #__ad_agency_zone ( `zoneid` , `banners` , `z_title` , `z_ordering` , `z_position` , `show_title` , `suffix`, `rotatebanners`, `rotaterandomize`, `rotating_time`, `show_adv_link`, `link_taketo`, `taketo_url`, `cellpadding`, `defaultad`, `keywords`, `adparams`, `ignorestyle`, `textadparams`) VALUES ({$zona['zoneid']}, {$zona['banners']}, '{$zona['z_title']}', {$zona['z_ordering']}, '{$zona['z_position']}', {$zona['showtitle']}, '{$zona['suffix']}', '{$zona['rotatebanners']}', '{$zona['rotaterandomize']}', '{$zona['rotating_time']}', '{$zona['show_adv_link']}', '{$zona['link_taketo']}', '{$zona['taketo_url']}', '{$zona['cellpadding']}', '{$zone['defaultad']}', '{$zone['keywords']}', '{$zona['adparams']}', '{$zona['ignorestyle']}','{$zona['textadparams']}')";
			$db->setQuery( $query );
			$db->query();
		} else {
			if (!$item->bind($zona)){
				$this->setError($item->getErrorMsg());
				return false;
			}
			if (!$item->check()) {
				$this->setError($item->getErrorMsg());
				return false;

			}
			if (!$item->store()) {
				$this->setError($item->getErrorMsg());
				return false;
			}
		}

		$menus = JRequest::getVar( 'menus', '', 'post', 'word' );
		$selections = JRequest::getVar( 'selections', array(), 'post', 'array' );
		JArrayHelper::toInteger($selections);
		// delete old module to menu item associations
		if (!isset($data['id']) || ($data['id']==0)) $data['id'] = $zona['zoneid'];
			$query = 'DELETE FROM #__modules_menu'
			. ' WHERE moduleid = '.(int) $data['id']
			;
			$db->setQuery( $query );
			if (!$db->query()) {
				return JError::raiseWarning( 500, $row->getError() );
			}

			// check needed to stop a module being assigned to `All`
			// and other menu items resulting in a module being displayed twice
			if ( $menus == 'all' ) {
				// assign new module to `all` menu item associations
				$query = 'INSERT INTO #__modules_menu'
				. ' SET moduleid = '.(int) $data['id'].' , menuid = 0'
				;
				$db->setQuery( $query );
				if (!$db->query()) {
					return JError::raiseWarning( 500, $row->getError() );
				}
			}
			else
			{
				foreach ($selections as $menuid)
				{
					// this check for the blank spaces in the select box that have been added for cosmetic reasons
					if ( (int) $menuid >= 0 ) {
						// assign new module to menu item associations
						$query = 'INSERT INTO #__modules_menu'
						. ' SET moduleid = '.(int) $data['id'] .', menuid = '.(int) $menuid
						;
						$db->setQuery( $query );
						if (!$db->query()) {
							return JError::raiseWarning( 500, $row->getError() );
						}
					}
				}
			}

		if($trigger_thumb_resize) {
			//echo "<pre>";var_dump($new_width);echo "<hr />";var_dump($new_height);die();
			$sql = "SELECT imgfolder FROM #__ad_agency_settings LIMIT 1";
			$db->setQuery($sql);
			$imgfolder = $db->loadResult();
			$JPATH_BASE = str_replace('administrator','',JPATH_BASE);
			$sql = "SELECT cb . * , b.advertiser_id, b.image_url
					FROM #__ad_agency_package_zone AS pz
					LEFT JOIN #__ad_agency_campaign AS c ON pz.package_id = c.otid
					LEFT JOIN #__ad_agency_campaign_banner AS cb ON c.id = cb.campaign_id
					LEFT JOIN #__ad_agency_banners AS b ON cb.banner_id = b.id
					WHERE pz.zone_id =".$data['id'];
			$db->setQuery($sql);
			$elements = $db->loadObjectList();

			//echo "<pre>";var_dump($elements);die();

			foreach($elements as $element){
				$img_url = $JPATH_BASE.'images'.DS.'stories'.DS.$imgfolder.DS.$element->advertiser_id.DS.$element->image_url;
				$thumb = $this->makeThumb($img_url, $new_width, $new_height);
				if($thumb != NULL) {
					$sql = "UPDATE `#__ad_agency_campaign_banner` SET `thumb` = '".$thumb."' WHERE `campaign_id` =".$element->campaign_id." AND `banner_id` =".$element->banner_id.";";
				} else {
					$sql = "UPDATE `#__ad_agency_campaign_banner` SET `thumb` = NULL WHERE `campaign_id` =".$element->campaign_id." AND `banner_id` =".$element->banner_id.";";
				}
				$sss[] = $sql;
				$db->setQuery($sql);
				$db->query();
			}
		}

        $sql = "SELECT package_id FROM #__ad_agency_package_zone WHERE zone_id = {$data['id']} LIMIT 1";
        $db->setQuery($sql);
        $has_packages = $db->loadResult();

        $session = &JFactory::getSession();
        if ($isNew) {
            $session->set("newzone-{$data['id']}", "1", 'adag');
        } elseif ($has_packages) {
            $session->clear("newzone-{$data['id']}", 'adag');
        }

        // echo "<pre>";var_dump($data);die();

        return $data['id'];
    }

	function makeThumb($file_url, $width, $height){
		$handle = new Upload($file_url);
		list($width_orig, $height_orig) = @getimagesize($file_url);
		if(!isset($width_orig)||($width_orig == NULL)) { return false; }
		$ratio_orig = $width_orig/$height_orig;
		if($width == '') { $width = $height*$ratio_orig; }
		elseif($height == '') { $height = $width/$ratio_orig; }
		if ($width/$height > $ratio_orig) {
		   $width = $height*$ratio_orig;
		} else {
		   $height = $width/$ratio_orig;
		}

		$check['width'] = (int)$width;
		$check['height'] = (int)$height;
		if(($check['width'] == 0)&&($check['height'] == 0)){
			return NULL;
		}

		$width = number_format($width,0);
		$height = number_format($height,0);

		$pieces = explode(DS,$file_url);
		$filename = explode('.',$pieces[count($pieces)-1]);
		$pieces[count($pieces)-1] = '';
		$pieces = implode(DS,$pieces);
		$dir_dest = $pieces;

		if ($handle->uploaded) {
			$handle->image_resize			= true;
			$handle->image_x				= $width;
			$handle->image_y				= $height;
			$handle->file_new_name_body		= $filename[0].'_w'.$width.'_h'.$height;
			$handle->file_overwrite			= true;
			$handle->jpeg_quality 			= 100;

			$handle->Process($dir_dest);
			if ($handle->processed) {
				return $handle->file_dst_name;
			}  else {
				return false;
			}
		} else {
			return false;
		}
	}

	function delete () {
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$database =  & JFactory::getDBO();
		$item = & $this->getTable('adagencyZone');

		$modul = & $this->getTable('adagencyModules');
		foreach ($cids as $cid) {
			if (!$item->delete($cid)) {
				$this->setError($item->getErrorMsg());
				return false;
			}
			if (!$modul->delete($cid)) {
				$this->setError($modul->getErrorMsg());
				return false;
			}
			$query = "DELETE FROM #__modules_menu WHERE moduleid ='".$cid."'";
			$database->setQuery( $query );
			$database->query();
		}
		return true;
	}

	function publish () {
		$db = & JFactory::getDBO();
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$task = JRequest::getVar('task', '', 'post');
		$item =& $this->getTable('adagencyZone');
		$res = 0;
		if ($task == 'publish'){
			$res = 1;
			$sql = "UPDATE #__modules SET published='1' WHERE id IN ('".implode("','", $cids)."')";
		} else {
			$res = -1;
			$sql = "UPDATE #__modules SET published='0' WHERE id IN ('".implode("','", $cids)."')";

		}
		$db->setQuery($sql);
		if (!$db->query() ){
			$this->setError($db->getErrorMsg());
		}
		return $res;
	}

};
?>
