<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ("joomla.aplication.component.model");
require_once('administrator/components/com_adagency/helpers/class.upload.php');

class adagencyModeladagencyCampaigns extends JModel {
	var $_attributes;
	var $_attribute;
	var $_id = null;

	function __construct () {
		parent::__construct();
		$cids = JRequest::getVar('cid', 0, '', 'array');
		$this->setId((int)$cids[0]);
	}

	function setId($id) {
		$this->_id = $id;
		$this->_attribute = null;
	}

	function getlistCampaigns () {
		if (empty ($this->_attributes)) {
			$my = & JFactory::getUser();
			$sql =  "SELECT c.id, c.name, c.quantity, c.validity, c.start_date, a.company, a.user_id, 
                        c.type, c.approved, c.status, COUNT(DISTINCT cb.banner_id) cnt, pk.validity
                        FROM #__ad_agency_campaign AS c 
                        LEFT OUTER JOIN #__ad_agency_campaign_banner AS cb 
                        ON c.id=cb.campaign_id	
                        LEFT JOIN #__ad_agency_order_type AS pk
                        ON c.otid = pk.tid
                        LEFT JOIN #__ad_agency_advertis AS a ON a.aid=c.aid 
                        WHERE a.user_id={$my->id} GROUP BY c.id ORDER BY c.id DESC";
			$this->_attributes = $this->_getList($sql);
		}
		return $this->_attributes;
	}

	function getCampaign() {
		if (empty ($this->_attribute)) {
			$this->_attribute =&$this->getTable("adagencycampaigns");
			$this->_attribute->load($this->_id);
		}
			$data = JRequest::get('post');

			if (!$this->_attribute->bind($data)){
				$this->setError($item->getErrorMsg());
				return false;

			}

			if (!$this->_attribute->check()) {
				$this->setError($item->getErrorMsg());
				return false;

			}
		return $this->_attribute;
	}

	function getPermForAdv($cid,$aid){
		if ($cid==0) {return true;}
		$db = & JFactory::getDBO();
		$sql = "SELECT id FROM #__ad_agency_campaign WHERE id='".$cid."' AND aid='".$aid."'";
		$db->setQuery($sql);
		$perm = $db->loadResult();
		if(isset($perm)&&($perm!=NULL)) { return true; } else { return false;}
	}

	function getAllPacks(){
		$db = & JFactory::getDBO();
		$query = 	"SELECT p . * , z.adparams
					FROM #__ad_agency_order_type AS p
					LEFT JOIN #__ad_agency_zone AS z ON p.location = z.zoneid";
		$db->setQuery($query);
		$result = $db->loadObjectList();
		return $result;
	}

	function getlistPackagesEdit () {
		$database = & JFactory::getDBO();
		$my = & JFactory::getUser();

		$database->setQuery("SELECT aid FROM #__ad_agency_advertis WHERE user_id={$my->id}");
		$aid = $database->loadResult();

		if (!$aid) return;
		$sql = "SELECT * FROM #__ad_agency_order_type AS p INNER JOIN #__ad_agency_order AS o WHERE p.tid = o.tid AND o.aid = {$aid} AND o.status='paid'";

		$database->setQuery($sql);
		$rows = $database->loadObjectList();
		if(count($rows)<1) {
			$cids=$_GET['cid'];
			$cids = $cids[0];
			$sql = "SELECT `otid` FROM #__ad_agency_campaign WHERE id = {$cids}";
			$database->setQuery($sql);
			$otid = $database->loadResult();
			$sql = "SELECT * FROM #__ad_agency_order_type WHERE tid = {$otid}";
			$database->setQuery($sql);
			$rows = $database->loadObjectList();
		}
		return $rows;

	}

	function getlistPackages () {
		$database = JFactory::getDBO();
		$my = & JFactory::getUser();
		$sql = "SELECT aid FROM #__ad_agency_advertis WHERE user_id = ".$my->id;
		$database->setQuery($sql);
		$advid = $database->loadResult();
		$sql = "SELECT r.*,z.adparams
				FROM `#__ad_agency_order_type` AS r
				LEFT JOIN #__ad_agency_zone AS z
				ON r.location = z.zoneid
				WHERE r.visibility <>0
				AND r.published = 1
				AND r.tid NOT
				IN (
					SELECT p.tid
					FROM `#__ad_agency_order_type` AS p, `#__ad_agency_order` AS o
					WHERE p.visibility <>0
					AND p.cost = '0.00'
					AND hide_after =1
					AND p.tid = o.tid
					AND o.aid = ".intval($advid)."
				)
				ORDER BY r.ordering ASC
		";
		//echo $sql;die();
		$database->setQuery($sql);
		$rows = $database->loadObjectList();

		return $rows;
	}

	function getBuyedAvailablePacksForAid() {
		$db =& JFactory::getDBO();
		$advertiser = $this->getCurrentAdvertiser();
		$aid = (int)$advertiser->aid;
		$sql = "SELECT * FROM #__ad_agency_order WHERE pack_id = '0' AND aid = $aid AND `status` = 'paid'";
		$db->setQuery($sql);
		$rezultat = $db->loadResult();
		return $rezultat;
	}

	function getTimeFormat() {
		$database =& JFactory::getDBO();
		$query = "SELECT params FROM #__ad_agency_settings ORDER BY id ASC LIMIT 1";
		$database->setQuery($query);
		$params = $database->loadResult();
		$params = @unserialize($params);
		if(isset($params['timeformat'])){
			$params = $params['timeformat'];
		} else { $params = "-1"; }
		return $params;
	}

	function getAdvInfo($id) {
		$db =& JFactory::getDBO();
		$query = "SELECT * FROM #__ad_agency_advertis WHERE aid=".$id;
		$db->setQuery($query);
		$result = $db->loadObject();
		return $result;
	}

	function getBannerCount() {
		$db = & JFactory::getDBO();
		$advertiser = $this->getCurrentAdvertiser();
		$aid = (int)$advertiser->aid;
		$sql = "SELECT count(*) FROM #__ad_agency_banners WHERE `advertiser_id`=$aid";
		$db->setQuery($sql);
		$res = $db->loadResult();
		return $res;
	}

	function getCurrentAdvertiser() {
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$sql = "SELECT * FROM #__ad_agency_advertis WHERE user_id = ".$my->id;
		$db->setQuery($sql);
		$result = $db->loadObject();
		return $result;
	}

	function formatime2($time,$option = 1){
		$date_time = explode(" ",$time);
		$date_time[0] = str_replace("/","-",$date_time[0]);
		$tdate = explode("-",$date_time[0]);
		if (($option == 1)||($option == 2)) {
			$aux=$tdate[0];
			$tdate[0]=$tdate[2];
			$tdate[2]=$aux;
		}
		elseif (($option == 3)||($option == 4)) {
			//mm-dd-yyyy
			$aux=$tdate[0];
			$tdate[0]=$tdate[2];
			$tdate[2]=$tdate[1];
			$tdate[1]=$aux;
		}
		$output = NULL;
		if(!isset($date_time[1])) {$date_time[1] = NULL;}
		$output = $tdate[0]."-".$tdate[1]."-".$tdate[2]." ".$date_time[1];
		return trim($output);
	}

	function getCountBannersPerAdv($id){
		$db = & JFactory::getDBO();
		$sql = "SELECT COUNT(id) FROM #__ad_agency_banners WHERE advertiser_id = ".$id;
		$db->setQuery($sql);
		$result = $db->loadResult();
		return $result;
	}

	function getZonesForPack($pack){
		$db = &JFactory::getDBO();
		if(isset($pack)&&(intval($pack)>0)){
			$sql = "SELECT z.*
					FROM #__ad_agency_package_zone AS pz
					LEFT JOIN #__modules AS m ON pz.zone_id = m.id
					LEFT JOIN #__ad_agency_zone AS z ON m.id = z.zoneid
					WHERE pz.package_id =".$pack;
			$db->setQuery($sql);
			$res =  $db->loadObjectList();

			//echo "<pre>";var_dump($packs);die();
			return $res;
		} else {
			return NULL;
		}
	}

	function getCmpById($id){
		$db = & JFactory::getDBO();
		$sql = "SELECT * FROM #__ad_agency_campaign WHERE id = ".$id;
		$db->setQuery($sql);
		$result = $db->loadObject();
		return $result;
	}

	function store () {
		$item =& $this->getTable('adagencyCampaigns');
		$data = JRequest::get('post');
		$database = &JFactory::getDBO();
		$db = &JFactory::getDBO();

		$update_status = 0;
		if(isset($data['banner'])&&(is_array($data['banner']))) {
			foreach($data['banner'] as $element){
				foreach($element as $key=>$val){
					if(($key == 'add')||($key == 'del')){
						$update_status = 1;
					}
				}
			}
		}

		$otid = $data['otid'];
		$data['key'] = NULL;
		if(isset($data['tfa'])) {
			if(($data['tfa']==1)||($data['tfa']==2)||($data['tfa']==7)||($data['tfa']==8)) {
				$data['start_date']=$this->formatime2($data['start_date'],1);
			} elseif(($data['tfa']==3)||($data['tfa']==4)||($data['tfa']==9)||($data['tfa']==10)) {
				$data['start_date']=$this->formatime2($data['start_date'],3);
			} else {
				$data['start_date']=$this->formatime2($data['start_date'],6);
			}
		}

		if(isset($data['banner'])) {
			$post_banner = $data['banner'];
		}
		$configs = $this->getInstance("adagencyConfig", "adagencyModel");
		$configs = $configs->getConfigs();
        $configs->params = @unserialize( $configs->params );

		$campnou=false;
        // Stuff for new campaigns
		if ( !isset($data['id']) || ($data['id'] < 1) ) {
			$campnou=true;
			$data['key']=md5(rand(1000,9999));

            if ( isset($configs->params['adslim']) ) {
                $data['params']['adslim'] = (int)$configs->params['adslim'];
            } else {
                $data['params']['adslim'] = 999;
            }

            $adslim = $data['params']['adslim'];

            $data['params'] = @serialize( $data['params'] );

        // Stuff for existing campaigns
        } else {
            $current_camp = $this->getCmpById($data['id']);
            $current_camp->params = @unserialize($current_camp->params);

            // echo "<pre>";var_dump($current_camp);die();

            if ( isset($current_camp->params['adslim']) ) {
                $adslim = (int)$current_camp->params['adslim'];
            } else {
                $adslim = 999;
            }

        }


		if ($campnou && $data['otid'] > 0) {
		$sql = "SELECT * FROM #__ad_agency_order_type WHERE tid=" . $data['otid'];
		$sqlz[] = $sql;
		$database->setQuery($sql);
		if(!$result = $database->query()) {
			echo $database->stderr();
			return;
			}
		$rows = $database->loadObjectList();
		$package_row = $rows[0];

		$data['type'] = $package_row->type;
		$data['cost'] = $package_row->cost;

		$sql4="UPDATE #__ad_agency_order SET `pack_id`='1' WHERE `tid`='".$package_row->tid."' AND `notes`='".$package_row->description."' AND `cost`='".$package_row->cost."'";
		$sqlz[] = $sql4;
		$database->setQuery($sql4);
		$database->query();

		if ($data['type'] == "fr") {
			$tmp_date_time = explode(" ", $data['start_date'], 2);
			if ($tmp_date_time[0]) {
				$tmp_date = explode("-", $tmp_date_time[0], 3);
			}
			else {
				$tmp_date[0] = 0;
				$tmp_date[1] = 0;
				$tmp_date[2] = 0;
			}

			if (isset($tmp_date_time[1])) {
				$tmp_time = explode(":", $tmp_date_time[1], 3);
			}
			else {
				$tmp_time[0] = 0;
				$tmp_time[1] = 0;
				$tmp_time[2] = 0;
			}

			$tmp = explode("|", $package_row->validity, 2);

			if ($tmp[1]=="day") {
				$data['validity'] = date("Y-m-d H:i:s", mktime($tmp_time[0],$tmp_time[1],$tmp_time[2],$tmp_date[1],$tmp_date[2] + $tmp[0],$tmp_date[0]));
			} elseif ($tmp[1]=="week") {
				$data['validity'] = date("Y-m-d H:i:s", mktime($tmp_time[0],$tmp_time[1],$tmp_time[2],$tmp_date[1],$tmp_date[2] + (7*$tmp[0]),$tmp_date[0]));
			} elseif ($tmp[1]=="month") {
				$data['validity'] = date("Y-m-d H:i:s", mktime($tmp_time[0],$tmp_time[1],$tmp_time[2],$tmp_date[1] + $tmp[0],$tmp_date[2],$tmp_date[0]));
			} elseif ($tmp[1]=="year") {
				$data['validity'] = date("Y-m-d H:i:s", mktime($tmp_time[0],$tmp_time[1],$tmp_time[2],$tmp_date[1],$tmp_date[2],$tmp_date[0] + $tmp[0]));
			}
		}
		else {
			$data['quantity'] = $package_row->quantity;
		}
	} else {
		$sql = "SELECT * FROM #__ad_agency_order_type WHERE tid=".$data['otid'];
		$sqlz[] = $sql;
		$database->setQuery($sql);
		if(!$result = $database->query()) {
			echo $database->stderr();
			return;
		}

		$rows = $database->loadObjectList();
		$package_row = $rows[0];
		$data['type'] = $package_row->type;
		$data['cost'] = $package_row->cost;
		$sql4="UPDATE #__ad_agency_order SET `pack_id`='1' WHERE `oid`='$typp'";
		$sqlz[] = $sql4;
		$database->setQuery($sql4);
		$database->query();

		if ($data['type'] == "fr") {
			$tmp_date_time = explode(" ", $data['start_date'], 2);
			if ($tmp_date_time[0]) {
				$tmp_date = explode("-", $tmp_date_time[0], 3);
			}
			else {
				$tmp_date[0] = 0;
				$tmp_date[1] = 0;
				$tmp_date[2] = 0;
			}

			if ($tmp_date_time[1]) {
				$tmp_time = explode(":", $tmp_date_time[1], 3);
			}
			else {
				$tmp_time[0] = 0;
				$tmp_time[1] = 0;
				$tmp_time[2] = 0;
			}

			$tmp = explode("|", $package_row->validity, 2);

			if ($tmp[1]=="day") {
				$data['validity'] = date("Y-m-d H:i:s", mktime($tmp_time[0],$tmp_time[1],$tmp_time[2],$tmp_date[1],$tmp_date[2] + $tmp[0],$tmp_date[0]));
			} elseif ($tmp[1]=="week") {
				$data['validity'] = date("Y-m-d H:i:s", mktime($tmp_time[0],$tmp_time[1],$tmp_time[2],$tmp_date[1],$tmp_date[2] + (7*$tmp[0]),$tmp_date[0]));
			} elseif ($tmp[1]=="month") {
				$data['validity'] = date("Y-m-d H:i:s", mktime($tmp_time[0],$tmp_time[1],$tmp_time[2],$tmp_date[1] + $tmp[0],$tmp_date[2],$tmp_date[0]));
			} elseif ($tmp[1]=="year") {
				$data['validity'] = date("Y-m-d H:i:s", mktime($tmp_time[0],$tmp_time[1],$tmp_time[2],$tmp_date[1],$tmp_date[2],$tmp_date[0] + $tmp[0]));
			}

		}
		else {

		}

	}

		// Check settings for auto-approve ads [begin]

		// Get global setting
		$query = "SHOW columns FROM #__ad_agency_campaign WHERE field='approved'";
		$sqlz[] = $query;
		$database->setQuery($query);
		$result = $database->loadRow();
		$aux_approved = $result[4];

		// Get Advertiser setting
		$info = $this->getAdvInfo($data['aid']);
		if(isset($info->apr_ads)&&($info->apr_cmp!='G')){
			$aux_approved = $info->apr_cmp;
		}
		if($aux_approved == 'N') {
			$aux_approved = 'P';
		}

		if(($data['id']>0)&&($aux_approved == 'P')&&($update_status == 1)){
			$data['approved'] = 'P';
		} elseif($data['id']<=0) {

			// v 2.0.6
			// If it's a new campaign and it's not free
			// than it's pending untill payment confirmation
			$sql = "SELECT cost FROM #__ad_agency_order_type WHERE tid = '".$data['otid']."' ;";
			$db->setQuery($sql);
			$package_cost = $db->loadResult();
			if($package_cost != "0.00"){
				$aux_approved = 'P';
			}

			$data['approved'] = $aux_approved;
		}
		// Check settings for auto-approve ads [end]

		if (!$item->bind($data)){
			$this->setError($item->getErrorMsg());
			return false;
		}

		if (!$item->check()) {
			$this->setError($item->getErrorMsg());
			return false;
		}

		if (!$item->store()) {
			$this->setError($item->getErrorMsg());
			return false;
		}

		if (!isset($data['id']) || $data['id']==0) $data['id'] = mysql_insert_id();
		if ($data['id']==0) {
			$ask = "SELECT `id` FROM `#__ad_agency_campaign` ORDER BY `id` DESC LIMIT 1 ";
			$sqlz[] = $ask;
			$db->setQuery( $ask );
			$data['id'] = $db->loadResult();
		}

		$sql_cbrw = "DELETE FROM `#__ad_agency_campaign_banner` WHERE `campaign_id` = ".$db->getEscaped($data['id']);
		$sqlz[] = $sql_cbrw;
		$db->setQuery($sql_cbrw);
		$db->query();

		$sql = "SELECT z.adparams FROM #__ad_agency_campaign AS c LEFT JOIN #__ad_agency_order_type AS p ON c.otid = p.tid LEFT JOIN #__ad_agency_zone AS z ON p.location = z.zoneid WHERE c.id = ".$data['id']." LIMIT 1";
		$sqlz[] = $sql;
		$db->setQuery($sql);
		$res = $db->loadResult();
		$zparams = @unserialize($res);

		//echo "<pre>";var_dump($zparams);die();
        // echo "<pre>";
        // var_dump($adslim);
        // die();

		foreach ($post_banner as $key=>$val) {
			$_banner = NULL;
			$rw = intval($val['rw'])!=0?intval($val['rw']):100;

			// del
			/*$query = "DELETE FROM #__ad_agency_campaign_banner WHERE campaign_id={$data['id']} AND banner_id={$key}";
			$sqlz[] = $query;
			$database->setQuery($query);
			if (!$database->query()) {}*/

			// add
			if ( isset($val['add']) && ($adslim != 0) ) {
				$query = "INSERT INTO #__ad_agency_campaign_banner(campaign_id, banner_id, relative_weighting) SELECT {$data['id']} , {$key}, {$val['rw']} FROM #__ad_agency_banners WHERE id = {$key} AND advertiser_id = {$data['aid']}";
				$sqlz[] = $query;
				$database->setQuery($query);
				if (!$database->query()) {}

				$sql = "SELECT advertiser_id, media_type, image_url FROM #__ad_agency_banners WHERE id = {$key}";
				$sqlz[] = $sql;
				$db->setQuery($sql);
				$_banner = $db->loadObject();
			//	echo "<pre>";var_dump($_banner);echo "<hr />";//die();

				if(($_banner->media_type == 'TextLink')&&($_banner->image_url != NULL)&&(strlen($_banner->image_url)>4)) {
					if(isset($_banner->image_url)&&($_banner->image_url != NULL)) {
						$img_url = JPATH_BASE.DS.'images'.DS.'stories'.DS.$configs->imgfolder.DS.$_banner->advertiser_id.DS.$_banner->image_url;
						@list($width_orig, $height_orig, $type, $attr) = @getimagesize($img_url);

						if(isset($data['adzones'][$key])){
							$query = "SELECT z.adparams,z.textadparams FROM #__ad_agency_zone AS z WHERE z.zoneid = ".$data['adzones'][$key];
							$db->setQuery($query);
							$res = $db->loadObject();
							$zparams = @unserialize($res->adparams);
							$paramz = @unserialize($res->textadparams);

							if(isset($paramz['mxsize'])&&(intval($paramz['mxsize'])>0)&&(isset($paramz['mxtype']))) {
								if((($paramz['mxtype'] == 'w')&&($paramz['mxsize'] < $zparams['width']))||($zparams['width'] == '')){
									//$ratio = $zparams['width']/$zparams['height'];$zparams['height'] = $zparams['width']/$ratio;
									$zparams['width'] = $paramz['mxsize'];
								} elseif((($paramz['mxtype'] == 'h')&&($paramz['mxsize'] < $zparams['height']))||($zparams['height'] == '')){
									//$ratio = $zparams['width']/$zparams['height'];$zparams['width'] = $ratio * $zparams['height'];
									$zparams['height'] = $paramz['mxsize'];
								}
							}
						}

						if(isset($zparams['width']) && isset($zparams['height']) && isset($width_orig) && ($width_orig != NULL) && isset($height_orig) && (($width_orig > $zparams['width'])||($height_orig > $zparams['height'])) ) {
							// make the thumb with the maximum size or the zone

							$thumb = $this->makeThumb($img_url, $zparams['width'], $zparams['height']);
							if($thumb != NULL) {
								$sql = "UPDATE `#__ad_agency_campaign_banner` SET `thumb` = '".$thumb."' WHERE `campaign_id` =".$data['id']." AND `banner_id` =".$key.";";
							} else {
								$sql = "UPDATE `#__ad_agency_campaign_banner` SET `thumb` = NULL WHERE `campaign_id` =".$data['id']." AND `banner_id` =".$key.";";
							}
							$sqlz[] = $sql;
							$db->setQuery($sql);
							$db->query();

						}
					}
				}

                $adslim--;
			}

			if($this->bannerExist($key, $data['id'])){
				$sql = "UPDATE `#__ad_agency_campaign_banner` SET `zone` = '".$data['adzones'][$key]."' WHERE `campaign_id` =".$data['id']." AND `banner_id` =".$key;
				$db->setQuery($sql);
				$db->query();
			}

			if (isset($val['del'])) {
				$sql = "DELETE FROM #__ad_agency_campaign_banner WHERE campaign_id = ".$data['id']."  AND banner_id = ".$key;
				$sqlz[] = $sql;
				$db->setQuery($sql);
				$db->query();
			}

			// rw update
			if (!isset($val['del']) && !isset($val['add'])) {
				$query = "UPDATE #__ad_agency_campaign_banner SET relative_weighting = {$rw}  WHERE campaign_id={$data['id']} AND banner_id={$key} AND relative_weighting!={$rw}";
				$sqlz[] = $query;
				$database->setQuery($query);
				if (!$database->query()) {

				}
			}
		}

	$camp_row = $this->getCmpById($data['id']);

	if ($campnou) {
		// if package is buyable than we make the campaign in pending
		$sql = "SELECT cost FROM #__ad_agency_order_type WHERE tid = ".intval($otid);
		$sqlz[] = $sql;
		$database->setQuery($sql);
		$package_cost = $database->loadResult();
		if($package_cost != "0.00"){
			$sql = "UPDATE `#__ad_agency_campaign` SET `approved` = 'P' WHERE `id` = '".$camp_row->id."'";
			$sqlz[] = $sql;
			$database->setQuery($sql);
			$database->query();
		}

	 	$sql = "SELECT a.user_id, a.company, a.telephone as phone, u.name, u.username, u.email FROM #__ad_agency_advertis AS a LEFT OUTER JOIN #__users as u on u.id=a.user_id WHERE a.aid={$camp_row->aid}	GROUP BY a.aid";
		$sqlz[] = $sql;
		$database->setQuery($sql);
		$user = $database->loadObject();
		if(isset($user)&&($user!=NULL)){
			if(!isset($user->company)) {$user->company = "N/A";}
			if(!isset($user->phone)) {$user->phone = "N/A";}
			if(isset($camp_row->approved)&&($camp_row->approved == 'Y')) {
				$camp_row->approved = JText::_('NEWADAPPROVED');
			} elseif (isset($camp_row->approved)&&($camp_row->approved == 'P')) {
				$camp_row->approved = JText::_('VIEW_CAMPAIGN_PENDING');
			} elseif(isset($camp_row->approved)&&($camp_row->approved == 'N')) {
				$camp_row->approved = JText::_('VIEW_CAMPAIGN_REJECTED');
			}

			$sql = "SELECT description FROM #__ad_agency_order_type WHERE tid = ".$camp_row->otid." LIMIT 1";
			$sqlz[] = $sql;
			$database->setQuery($sql);
			$camp_row->otid = $database->loadResult();

			$subject=$configs->sbnewcmp;
			$message=$configs->bodynewcmp;
			$subject =str_replace('{name}',$user->name,$subject);
			$subject =str_replace('{email}',$user->email,$subject);
			$subject =str_replace('{phone}',$user->phone,$subject);
			$subject =str_replace('{campaign}',$camp_row->name,$subject);
			$subject =str_replace('{company}',$user->company,$subject);
			$subject =str_replace('{approve_campaign_url}',JURI::root()."index.php?option=com_adagency&controller=adagencyCampaigns&task=manage&action=approve&key=".$data['key']."&cid=".$camp_row->id,$subject);
			$subject =str_replace('{decline_campaign_url}',JURI::root()."index.php?option=com_adagency&controller=adagencyCampaigns&task=manage&action=decline&key=".$data['key']."&cid=".$camp_row->id,$subject);
			$subject =str_replace('{approval_status}',$camp_row->approved,$subject);
			$subject =str_replace('{package}',$camp_row->otid,$subject);

			$message =str_replace('{name}',$user->name,$message);
			$message =str_replace('{email}',$user->email,$message);
			$message =str_replace('{phone}',$user->phone,$message);
			$message =str_replace('{company}',$user->company,$message);
			$message =str_replace('{campaign}',$camp_row->name,$message);
			$message =str_replace('{package}',$camp_row->otid,$message);
			$message =str_replace('{approve_campaign_url}',JURI::root()."index.php?option=com_adagency&controller=adagencyCampaigns&task=manage&action=approve&key=".$data['key']."&cid=".$camp_row->id,$message);
			$message =str_replace('{decline_campaign_url}',JURI::root()."index.php?option=com_adagency&controller=adagencyCampaigns&task=manage&action=decline&key=".$data['key']."&cid=".$camp_row->id,$message);
			$message =str_replace('{approval_status}',$camp_row->approved,$message);

			JUtility::sendMail( $configs->fromemail, $configs->fromname, $configs->adminemail, $subject, $message, 1 );
		}
		if(isset($_SESSION['LCC'])){
			$_SESSION['LCC'] = NULL;$_SESSION['LCC2']=NULL;
			unset($_SESSION['LCC']);unset($_SESSION['LCC2']);
		}

		$_SESSION['LCC'] = $camp_row->id;
		$_SESSION['LCC2'] = $otid;

		$item_id = JRequest::getInt('Itemid','0');
		if($item_id != 0) { $Itemid = "&Itemid=".$item_id; } else { $Itemid = NULL; }


		global $mainframe;
		$mainframe->redirect("index.php?option=com_adagency&controller=adagencyOrders&task=order&tid=".$data['otid'].$Itemid);
	}

		//echo "<pre>";var_dump($sqlz);die();
		return true;
	}

    function savechangecb() {
        $db = &JFactory::getDBO();
        $adv = $this->getCurrentAdvertiser();
        $data = &JRequest::get('post');
        $data['campaignid'] = (int) $data['campaignid'];
        $deleted_banners = "(" . implode(',', $data['todel']) . ")";

        $sql = "DELETE FROM #__ad_agency_campaign_banner
                WHERE campaign_id = {$data['campaignid']}
                AND banner_id IN " . $deleted_banners;
        $sqlz[] = $sql;
        $db->setQuery($sql);
        $db->query();

        // return the new count of banners that are assigned
        // to campaign
        $sql = "SELECT COUNT( banner_id )
                FROM #__ad_agency_campaign_banner
                WHERE campaign_id = " . $data['campaignid'];
        $sqlz[] = $sql;
        $db->setQuery($sql);
        $totalads = $db->loadResult();
        $vars = new stdClass();
        $vars->totalads = $totalads;
        $vars->cid = $data['campaignid'];

        return $vars;
    }

    function bannerExist($b_id, $c_id){
		$db =& JFactory::getDBO();
		$sql = "select count(*) from #__ad_agency_campaign_banner where banner_id=".$b_id." and campaign_id=".$c_id;
		$db->setQuery($sql);
		$db->query();
		$result = $db->loadResult();
		if($result == "0"){
			return false;
		}
		return true;
	}

    function getCampBanners($id) {
        $db = &JFactory::getDBO();
        $sql ="
            SELECT b . *
            FROM #__ad_agency_campaign_banner AS cb
            JOIN #__ad_agency_banners AS b ON cb.banner_id = b.id
            WHERE cb.campaign_id = {$id}
        ";
        $db->setQuery($sql);
        $res = $db->loadObjectList();
        return $res;
    }

	function getApprSts($advid){
		$db = &JFactory::getDBO();
		$query = "SHOW columns FROM #__ad_agency_campaign WHERE field='approved'";
		$db->setQuery($query);
		$result = $db->loadRow();
		$aux_approved = $result[4];

		// Get Advertiser setting
		$info = $this->getAdvInfo($advid);
		if(isset($info->apr_ads)&&($info->apr_cmp!='G')){
			$aux_approved = $info->apr_cmp;
		}
		if($aux_approved == 'N') {
			$aux_approved = 'P';
		}
		return $aux_approved;
	}

	function makeThumb($file_url, $width, $height){
		$handle = new Upload($file_url);

		list($width_orig, $height_orig) = @getimagesize($file_url);
		if(!isset($width_orig)||($width_orig == NULL)) { return false; }
		$ratio_orig = $width_orig/$height_orig;
		if($width == '') { $width = $height*$ratio_orig; }
		elseif($height == '') { $height = $width/$ratio_orig; }
		if ($width/$height > $ratio_orig) {
		   $width = $height*$ratio_orig;
		} else {
		   $height = $width/$ratio_orig;
		}

		$check['width'] = (int)$width;
		$check['height'] = (int)$height;
		if(($check['width'] == 0)&&($check['height'] == 0)){
			return NULL;
		}

		$width = number_format($width,0);
		$height = number_format($height,0);

		$pieces = explode(DS,$file_url);
		$filename = explode('.',$pieces[count($pieces)-1]);
		$pieces[count($pieces)-1] = '';
		$pieces = implode(DS,$pieces);
		$dir_dest = $pieces;

		if ($handle->uploaded) {
			$handle->image_resize			= true;
			$handle->image_x				= $width;
			$handle->image_y				= $height;
			$handle->file_new_name_body		= $filename[0].'_w'.$width.'_h'.$height;
			$handle->file_overwrite			= true;
			$handle->jpeg_quality 			= 100;

			$handle->Process($dir_dest);
			if ($handle->processed) {
				return $handle->file_dst_name;
			}  else {
				return false;
			}
		} else {
			return false;
		}
	}

	function updateMediaType($bans){
		if(isset($bans)&&(is_array($bans))){
			foreach($bans as $ban){
				$ban->media_type = strtolower($ban->media_type);
				if($ban->media_type == 'advanced') { $ban->media_type = 'affiliate'; }
				if($ban->media_type == 'textlink') { $ban->media_type = 'textad'; }
			}
		}

		return $bans;
	}

	function updateZoneList($bans,$zones,$camp_id = 0){
		$db = &JFactory::getDBO();
		if(isset($bans) && isset($zones)){
			foreach($bans as $ban){
				if(isset($camp_id)&&(intval($camp_id)>0)&&isset($ban->id)&&(intval($ban->id)>0)){
					$sql = "SELECT zone FROM #__ad_agency_campaign_banner WHERE banner_id = ".$ban->id." AND campaign_id = ".$camp_id;
					$db->setQuery($sql);
					$sel_zone = $db->loadResult();
				} else {
					$sel_zone = NULL;
				}
				$ban->zones = "<select class='w145' name='adzones[".$ban->id."]' id='adzones_".$ban->id."'>";
				$ban->zones .= "<option value=''>".JText::_("ADAG_ZONE_FOR_AD")."</option>";
				if(is_array($zones))
				foreach($zones as $zone){
					$types = NULL; $b_with_size = false;
					if(is_array($zone->adparams))
					foreach($zone->adparams as $key=>$value){
						if($key == 'affiliate') { $types[] = $key; $b_with_size = true; }
						if($key == 'textad') { $types[] = $key; }
						if($key == 'standard') { $types[] = $key; $b_with_size = true; }
						if($key == 'flash') { $types[] = $key; $b_with_size = true; }
						if($key == 'popup') { $types[] = $key; }
						if($key == 'transition') { $types[] = $key; }
						if($key == 'floating') { $types[] = $key; }
					}
					if(is_array($types) && in_array($ban->media_type,$types)) {
						if((!isset($zone->adparams['width'])||($zone->adparams['width'] == '')||!isset($zone->adparams['height'])||($zone->adparams['height'] == ''))||($b_with_size == false)){
							if($sel_zone == $zone->zoneid) { $selected = " selected='selected' "; } else { $selected = NULL;}
							$ban->zones .= "<option value='".$zone->zoneid."' ".$selected.">".$zone->z_title."</option>";
						} elseif(($b_with_size == true)&&($zone->adparams['width'] == $ban->width)&&($zone->adparams['height'] == $ban->height)){
							if($sel_zone == $zone->zoneid) { $selected = " selected='selected' "; } else { $selected = NULL;}
							$ban->zones .= "<option value='".$zone->zoneid."' ".$selected.">".$zone->z_title."</option>";
						}
					}
				}
				$ban->zones .= "</select>";
			}
		}
		//echo "<pre>";var_dump($bans);die();
		return $bans;
	}

	function manage($key,$action,$cid){
		global $mainframe;
		$db	= & JFactory::getDBO();
		$sql = "SELECT approved FROM `#__ad_agency_campaign` WHERE `id`='".$cid."' AND `key`='".$key."' LIMIT 1";
		$db->setQuery($sql);
		$res = $db->loadResult();
		if(isset($res)&&($res!=NULL)){
			if($action == "approve"){
				$sql = "UPDATE `#__ad_agency_campaign` SET `approved` = 'Y' WHERE `id` ='".$cid."';";
				$db->setQuery($sql);
				if($db->query()){
					echo "<img src='".JURI::root()."components/com_adagency/images/tick.png' />".JText::_('ADAG_CAMSG');
				}

				//send email notifications
				$sql = "SELECT c.name AS cname, u.name, u.username, u.email FROM #__ad_agency_campaign AS c LEFT JOIN #__ad_agency_advertis as a ON a.aid=c.aid LEFT JOIN #__users as u ON u.id=a.user_id WHERE c.id = '".$cid."' LIMIT 1";
				$db->setQuery($sql);
				if(!$result = $db->query()) {
					echo $db->stderr();
					return;
				}
				$user = $db->loadObject();

				$sql = "SELECT * FROM #__ad_agency_settings ORDER BY id ASC LIMIT 1";
				$db->setQuery($sql);
				$configs = $db->loadObject();

				$subject=$configs->sbcmpappv;
				$message=$configs->bodycmpappv;
				//$subject=$configs->sbcmpdis;
				//$message=$configs->bodycmpdis;
				$subject =str_replace('{name}',$user->name,$subject);
				$subject =str_replace('{login}',$user->username,$subject);
				$subject =str_replace('{email}',$user->email,$subject);
				$subject =str_replace('{campaign}',$user->cname,$subject);
				$message =str_replace('{name}',$user->name,$message);
				$message =str_replace('{login}',$user->username,$message);
				$message =str_replace('{email}',$user->email,$message);
				$message =str_replace('{campaign}',$user->cname,$message);
				JUtility::sendMail( $configs->fromemail, $configs->fromname, $user->email, $subject, $message, 1 );

				//send email notifications

			} elseif ($action == "decline"){
				$sql = "UPDATE `#__ad_agency_campaign` SET `approved` = 'N' WHERE `id` ='".$cid."';";
				$db->setQuery($sql);
				if($db->query()){
					echo "<img src='".JURI::root()."components/com_adagency/images/publish_x.png' />".JText::_('ADAG_CDMSG');
				}
				//send email notifications
				$sql = "SELECT c.name AS cname, u.name, u.username, u.email FROM #__ad_agency_campaign AS c LEFT JOIN #__ad_agency_advertis as a ON a.aid=c.aid LEFT JOIN #__users as u ON u.id=a.user_id WHERE c.id = '".$cid."' LIMIT 1";
				$db->setQuery($sql);
				if(!$result = $db->query()) {
					echo $db->stderr();
					return;
				}
				$user = $db->loadObject();

				$sql = "SELECT * FROM #__ad_agency_settings ORDER BY id ASC LIMIT 1";
				$db->setQuery($sql);
				$configs = $db->loadObject();

				//$subject=$configs->sbcmpappv;
				//$message=$configs->bodycmpappv;
				$subject=$configs->sbcmpdis;
				$message=$configs->bodycmpdis;
				$subject =str_replace('{name}',$user->name,$subject);
				$subject =str_replace('{login}',$user->username,$subject);
				$subject =str_replace('{email}',$user->email,$subject);
				$subject =str_replace('{campaign}',$user->cname,$subject);
				$message =str_replace('{name}',$user->name,$message);
				$message =str_replace('{login}',$user->username,$message);
				$message =str_replace('{email}',$user->email,$message);
				$message =str_replace('{campaign}',$user->cname,$message);
				JUtility::sendMail( $configs->fromemail, $configs->fromname, $user->email, $subject, $message, 1 );

				//send email notifications

			} else {
				$mainframe->redirect("index.php");
			}
		} else {
			$mainframe->redirect("index.php");
		}
	}

	function delete () {
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$item =& $this->getTable('adagencyCampaigns');
		$database = & JFactory::getDBO();
		foreach ($cids as $cid) {
			if (!$item->delete($cid)) {
				$this->setError($item->getErrorMsg());
				return false;
			}
			$query = "DELETE FROM #__ad_agency_campaign_banner WHERE campaign_id = '".$cid."'";
			$database->setQuery( $query );
			$database->query();
			$query = "DELETE FROM #__ad_agency_stat WHERE campaign_id = '".$cid."'";
			$database->setQuery( $query );
			$database->query();
		}
		return true;
	}

	function publish () {
		$db =& JFactory::getDBO();
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$task = JRequest::getVar('task', '', 'post');
		$item =& $this->getTable('adagencyCampaigns');
		if ($task == 'approve'){
			$sql = "update #__ad_agency_campaign set approved='Y' where id in ('".implode("','", $cids)."')";
		} else {
			$sql = "update #__ad_agency_campaign set approved='N' where id in ('".implode("','", $cids)."')";

		}
		$db->setQuery($sql);
		if (!$db->query() ){
			$this->setError($db->getErrorMsg());
			return false;
		}
	}

	function getcmplistAdvertisers () {
		if (empty ($this->_package)) {
			$db =& JFactory::getDBO();
			$sql = "SELECT a.aid, a.company, a.user_id FROM #__ad_agency_advertis as a, #__users as b WHERE a.user_id = b.id ORDER BY a.company ASC";
			$db->setQuery($sql);
			if (!$db->query()) {
				echo $db->stderr();
				return;
			}
			$this->_package = $db->loadObjectList();

		}
		return $this->_package;

	}

	function pause() {
		$db =& JFactory::getDBO();
		$cmp = intval($_GET['cid']);
		$sql = "update #__ad_agency_campaign set status='0' where id='".$cmp."'";
		$db->setQuery($sql);
			if (!$db->query() ){
				$this->setError($db->getErrorMsg());
				return false;
			}
		return true;
	}

	function unpause() {
		$db =& JFactory::getDBO();
		$cmp = intval($_GET['cid']);
		$sql = "update #__ad_agency_campaign set status='1' where id='".$cmp."'";
		$db->setQuery($sql);
			if (!$db->query() ){
				$this->setError($db->getErrorMsg());
				return false;
			}
		return true;
	}

	function io() {

	}

};
?>
