<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ("joomla.aplication.component.model");
require_once('administrator/components/com_adagency/helpers/class.upload.php');

class adagencyModeladagencyTextlink extends JModel {
	var $_licenses;
	var $_license;
	var $_id = null;
	var $_total = 0;
	var $_pagination = null;

	function __construct () {
		parent::__construct();
		$cids = JRequest::getVar('cid', 0, '', 'array');
		$this->setId((int)$cids[0]);
		global $mainframe, $option;
		// Get the pagination request variables
		$limit = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );
		$this->setState('limit', $limit); // Set the limit variable for query later on
		$this->setState('limitstart', $limitstart);
	}

	function setId($id) {
		$this->_id = $id;
		$this->_license = null;
	}

	function getPagination(){
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))	{
			jimport('joomla.html.pagination');
			if (!$this->_total) $this->getListAds();
			$this->_pagination = new JPagination( $this->_total, $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}

	function getlistAds () {
		if (empty ($this->_licenses)) {
			$sql = "select a.aid AS advertiser_id2, a.company AS advertiser, concat(width,'x',height) AS size_type,
			b.*,m.id mid, m.title zone_name
			FROM #__ad_agency_banners AS b
			left outer join #__ad_agency_advertis AS a ON b.advertiser_id = a.aid
			LEFT JOIN #__ad_agency_campaign_banner AS cb ON cb.banner_id = b.id
			LEFT JOIN #__modules AS m ON m.id=b.zone
			WHERE 1=1
			GROUP BY b.id 
			ORDER BY b.id DESC 
			";
		$this->_licenses = $this->_getList($sql);
		$rows = $this->_licenses;
		$ids = array();
		foreach($rows as $row)
			array_push($ids, $row->id);
		$ids = implode(",", $ids);
		
		if ($ids == "") $ids = "null";
		$sql2 = <<<eosql
select
			banner_id,
			sum(case s.type when 'impressions' then s.how_many else 0 end) as impressions, 
			sum(case s.type when 'click' then s.how_many else 0 end) as click,
			TRUNCATE((sum(case s.type when 'click' then s.how_many else 0 end)/(sum(case s.type when 'impressions' then s.how_many else 0 end)/100)),2) as click_rate
			FROM #__ad_agency_stat s
where banner_id in($ids)
group by banner_id
eosql;
		$this->_licenses = $this->_getList($sql2);
		$rows2 = $this->_licenses;
		foreach($rows2 as $row2)
			foreach($rows as $k=>$row)
				if($row2->banner_id == $row->id)
				{
					$rows[$k]->impressions = $row2->impressions;
					$rows[$k]->click = $row2->click;
					$rows[$k]->click_rate = $row2->click_rate;
					$sqlz	= "SELECT count(c.id) FROM #__ad_agency_campaign c INNER JOIN #__ad_agency_campaign_banner cb ON c.id = cb.campaign_id WHERE banner_id = {$row->id}";
					$this->_licenses = $this->_getList($sqlz);
				}
			$this->_licenses = $rows;
		}	
		return $this->_licenses;
	}	

	function getad() {
		if (empty ($this->_package)) {
			$this->_package =& $this->getTable("adagencyAds");
			$this->_package->load($this->_id);
			$data = JRequest::get('post');
			if (!$this->_package->bind($data)){
				$this->setError($item->getErrorMsg());
				return false;
	
			}
			if (!$this->_package->check()) {
				$this->setError($item->getErrorMsg());
				return false;
			}
		}
		return $this->_package;
	}
	
	function getWH($id){
		$db =& JFactory::getDBO();	
		$sql = "SELECT width, height FROM #__ad_agency_banners WHERE id='".$id."'";
		$db->setQuery($sql);
		return $db->loadObject();
	}
			
	function getPrevZones(){
		$db =& JFactory::getDBO();	
		$sql = "SELECT zoneid, z_title, textadparams FROM `#__ad_agency_zone` WHERE `adparams` LIKE '%textad%'";
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		//echo "<pre>";var_dump($result);die();
		return $result;
	}	
	
	function getImageInfo($imagepath){
		return @getimagesize($imagepath);
	}
	
	function getAdvInfo($id){
		$db =& JFactory::getDBO();	
		$query = "SELECT * FROM #__ad_agency_advertis WHERE aid=".$id;
		$db->setQuery($query);
		$result = $db->loadObject();
		return $result;
	}	

	function getCurrentAdvertiser(){
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$sql = "SELECT * FROM #__ad_agency_advertis WHERE user_id = ".$my->id;
		$db->setQuery($sql);
		$result = $db->loadObject();
		return $result;
	}
	
	function getAdById($id){
		$db = & JFactory::getDBO();
		$sql = "SELECT * FROM #__ad_agency_banners WHERE id = ".$id;
		$db->setQuery($sql);
		$result = $db->loadObject();
		return $result;
	}

	function getChannel($bid) {
		$db = &JFactory::getDBO();
		if(isset($bid)) {
			$sql = "SELECT * FROM `#__ad_agency_channels` WHERE banner_id =".intval($bid)." LIMIT 1";
			$db->setQuery($sql); 
			$result = $db->loadObject();
			if(!isset($result->id)) { return NULL; }
			$sql = "SELECT s.type, s.option, s.logical, s.data FROM `#__ad_agency_channels` AS c, `#__ad_agency_channel_set` AS s WHERE c.id = ".$result->id." AND c.id = s.channel_id ORDER BY s.id ASC";
			$db->setQuery($sql);
			$result->sets = $db->loadObjectList();
			
			//echo "<pre>";var_dump($result);die();
		} else {
			$result = NULL;
		}
		return $result;
	}
	
	function processCampZones($camps){
		$zones = array();
		if(isset($camps)&&(is_array($camps))){
			foreach($camps as $camp){
				if(!isset($zones[$camp->id])) { $zones[$camp->id] = $this->getAllZonesForCampByCampId($camps,$camp->id); }
			}
		}
		return $zones;
	}
	
	function getAllZonesForCampByCampId($camps, $camp_id){
		$resp = array();
		if(isset($camps)&&(is_array($camps))){
			$i = 1;
			foreach($camps as $camp){
				if($camp->id == $camp_id) {
					$resp[$i]['zoneid'] = $camp->zoneid;
					$resp[$i]['z_title'] = $camp->z_title;
					$i++;
				}
			}
		}
		return $resp;
	}
	
	function createSelectBox($czones,$ad_id){
		$db = &JFactory::getDBO();
		$select = array();
		if(isset($czones)&&(is_array($czones))){
			foreach($czones as $key=>$value){
				$sql = "SELECT zone FROM #__ad_agency_campaign_banner WHERE banner_id = ".$ad_id." AND campaign_id = ".$key;
				$db->setQuery($sql);
				$sel_zone = $db->loadResult();
				$select[$key] = "<select name='czones[".$key."]' id='czones_".$key."' class='w145'>";
				$select[$key] .= "<option value='0'>".JText::_('ADAG_ZONE_FOR_AD')."</option>";
				if(is_array($value)){
					foreach($value as $val){
						if($sel_zone == $val['zoneid']) { $this_selected = " selected='selected' "; } else { $this_selected = NULL; }
						$select[$key] .= "<option value='".$val['zoneid']."' ".$this_selected.">".$val['z_title']."</option>";
					}
				}
				$select[$key] .= "</select>";
			}
		}
		return $select;
	}
	
	function getCampsByAid($adv_id, $distinct = 0) {
		$db = JFactory::getDBO();
		$sqls = "
			SELECT c.id, c.name, c.params, z.*
			FROM #__ad_agency_campaign AS c 
			JOIN #__ad_agency_order_type AS o 
			ON c.otid = o.tid
			JOIN #__ad_agency_package_zone AS pz
			ON pz.package_id = o.tid  
			JOIN #__ad_agency_zone AS z 
			ON z.zoneid = pz.zone_id 
			WHERE c.aid = ".$adv_id." AND z.adparams LIKE '%textad%'
		";
        if ($distinct == 1) { $sqls .= "GROUP BY c.id"; }
        //echo $sqls;die();
		$db->setQuery($sqls);
		$camps = $db->loadObjectList();	
		foreach($camps as &$element) {
			$element->adparams = @unserialize($element->adparams);
            $element->params = @unserialize($element->params);
            
            // Select total banners for each campaign
            $sql = "SELECT COUNT( campaign_id )
                       FROM `#__ad_agency_campaign_banner`
                       WHERE `campaign_id` = " . $element->id;
            $db->setQuery($sql);
            $element->totalbanners = $db->loadResult();
		}
		//echo "<pre>";var_dump($camps);die();
		return $camps;
	}

	function getSelectedCamps($advertiser_id,$adid){
		$db = JFactory::getDBO();
		$sql="SELECT DISTINCT cb.campaign_id FROM #__ad_agency_banners AS b LEFT OUTER JOIN #__ad_agency_campaign_banner AS cb ON cb.banner_id=b.id WHERE b.advertiser_id=$advertiser_id AND b.id=$adid";
		$db->setQuery($sql);
		$these_campaigns=$db->loadResultArray();
		return $these_campaigns;
	}
		
	function delete_geo($bid, $aid) {
		$db = &JFactory::getDBO();
		$temp = NULL;
		if(isset($bid)&&isset($aid)) {
			$sql0 = 'SELECT id FROM #__ad_agency_channels WHERE banner_id = "'.$bid.'" AND advertiser_id = "'.$aid.'" LIMIT 1';
			$db->setQuery($sql0);
			$id_to_del = $db->loadResult();
			
			if(isset($id_to_del)&&($id_to_del != NULL)) {
				/*$sql1 = 'DELETE FROM #__ad_agency_channels WHERE id = "'.$id_to_del.'"';
				$db->setQuery($sql1);
				if(!$db->query()) { return false; }*/
				
				$sql2 = 'DELETE FROM #__ad_agency_channel_set WHERE channel_id = "'.$id_to_del.'"';
				$db->setQuery($sql2);
				if(!$db->query()) { return false; }
			}
		}
		
		if(isset($id_to_del)) { return $id_to_del; } else { return -1; }
	}
	
	function store_geo($bid = NULL){
		require_once('components/com_adagency/helpers/channel_fcs.php');
	}

	function store () {
		$database = & JFactory::getDBO();
		$db = & JFactory::getDBO();
		$item =& $this->getTable('adagencyAds');        
        $adsModel = $this->getInstance("adagencyAds", "adagencyModel");
		$configs = $this->getInstance("adagencyConfig", "adagencyModel");
		$configs = $configs->getConfigs();
		$notify = JRequest::getInt('id');
		$advid = $this->getCurrentAdvertiser();
		if(isset($advid->aid)) { $advid = $advid->aid; } else { $advid = 0;}
		$data = JRequest::get('post');
		if(isset($data['width'])&&(isset($data['height']))) { 
			$data['width']=NULL;$data['height']=NULL;
			unset($data['width']);unset($data['height']);
		}
		//echo "<pre>";var_dump($data);die();
		if($data['id']==0){
			$data['created'] = date("Y-m-d");
			$data['key'] = md5(rand(1000,9999));
		} else {
			$data['key'] = NULL;
		}
		//echo "<pre>";var_dump($data);die();
		if(isset($data['adv_cmp'])) {$adv_cmp=$data['adv_cmp'];}
		$res = true;
		
		// Check settings for auto-approve ads [begin]
		$advertiser = $this->getCurrentAdvertiser();
		if(isset($advertiser->apr_ads)&&($advertiser->apr_ads!='G')){
			$approved = $advertiser->apr_ads;
		} else {
			$sql = "SHOW COLUMNS FROM `#__ad_agency_banners` WHERE field = 'approved'";
			$db->setQuery($sql);
			$res = $db->loadObject();
			$approved = $res->Default;
		}
		if($approved == 'N') { $approved = 'P'; }
		$data['approved'] = $approved;
		// Check settings for auto-approve ads [end]
		
		// if the ad is not new then ->
		if(isset($data['id'])&&($data['id']>0)){
			$ex_ad = $this->getAdById($data['id']);
			$ex_ad->parameters = @unserialize($ex_ad->parameters);
			// if the ad was approved or declined and the new status would be 'pending', make sure changes occured to it!
			if(($ex_ad->approved != 'P')&&($data['approved'] == 'P')){
				// if no change has been made, let the status be as it was
				if(($ex_ad->title == $data['title'])&&($ex_ad->description == $data['description'])&&($ex_ad->target_url == $data['target_url'])&&($ex_ad->image_url == $data['image_url'])&&(stripslashes(@$ex_ad->parameters['alt_text_t']) == $data['linktitle'])&&(stripslashes(@$ex_ad->parameters['alt_text']) == $data['linktext'])&&(stripslashes(@$ex_ad->parameters['alt_text_a']) == $data['linkaction'])) {
					//&&(stripslashes(@$ex_ad->parameters['img_alt']) == $data['parameters']['img_alt'])
					$data['approved'] = $ex_ad->approved;
				}
			}
		}		
			
		if(isset($ex_ad->parameters)){
			foreach($data['parameters']	as $key=>$value){
				$ex_ad->parameters[$key] = $value;
			}
			$data['parameters'] = $ex_ad->parameters;
		}

		if(!isset($data['parameters']['img_alt'])||($data['parameters']['img_alt'] == '')) {
			$data['parameters']['img_alt'] = $data['target_url'];
		} 
		
		//echo "<pre>";var_dump($data);die();

		$data['parameters'] = serialize($data['parameters']);
		
		if (!$item->bind($data)){
			$res = false;
		}
		if (!$item->check()) {
			$res = false;
		}
		if (!$item->store()) {
			$res = false;
		}
		if (!isset($data['id']) || $data['id']==0) $data['id'] = mysql_insert_id();
		$idi = $data['id'];
		if ($idi==0) {
			$ask = "SELECT `id` FROM `#__ad_agency_banners` ORDER BY `id` DESC LIMIT 1 ";
			$db->setQuery( $ask );
			$idi = $db->loadResult();
		}
		if(isset($idi)) {
			$this->store_geo($idi);
		}		
		
		$query = "DELETE FROM #__ad_agency_campaign_banner WHERE banner_id={$idi}";
		$db->setQuery($query);
		$db->query();
		
		if(isset($data['image_url'])&&($data['image_url'] != NULL)) {
			$img_url = JPATH_BASE.DS.'images'.DS.'stories'.DS.$configs->imgfolder.DS.$data['advertiser_id'].DS.$data['image_url'];
			//echo $img_url."<br />";
			@list($width_orig, $height_orig, $type, $attr) = @getimagesize($img_url);
			/*echo "Width original: ";var_dump($width_orig)."<br />";
			echo "Height original: ".$height_orig."<br />";
			echo "Type: ".$type."<br />";
			echo "Attr: ".$attr."<br />";
			echo "<pre>";var_dump($adv_cmp);echo "<hr />";//die();
			//die();*/
		}
		
		$fls = array();
		
        $campLimInfo = $adsModel->getCampLimInfo();
		//echo "<pre>";var_dump($campLimInfo);echo "<hr />";//die();
        
		if(isset($adv_cmp)){
			foreach ($adv_cmp as $val) {	

                $zparams = NULL;$thumb = NULL;
                if(strstr($val,"|no|")) { $yes_no=0;} else { $yes_no=1; }
                $val = str_replace("|yes|","",$val);
                $val = str_replace("|no|","",$val);
            
				if ( ($val) && ( 
                    ( !isset($campLimInfo[$val])) || ( $campLimInfo[$val]['adslim'] > $campLimInfo[$val]['occurences'] )
                ) ) {
					if($yes_no == 1) {
                        $query = "INSERT INTO `#__ad_agency_campaign_banner` (`campaign_id` ,`banner_id` ,`relative_weighting` ,`thumb`, `zone`) 
                                        VALUES ('".$val."', '".$idi."', '100', NULL, ".$data['czones'][$val].");";
						//$query = "INSERT INTO #__ad_agency_campaign_banner VALUES ({$val},{$idi},100)";
						$db->setQuery($query);
						$db->query();
						
						$query = "SELECT z.adparams,z.textadparams FROM #__ad_agency_zone AS z WHERE z.zoneid = ".$data['czones'][$val];
						$db->setQuery($query);
						$res = $db->loadObject();
						$zparams = @unserialize($res->adparams);
						$ex_ad->parameters = @unserialize($res->textadparams);
						
						if(isset($ex_ad->parameters['mxsize'])&&(intval($ex_ad->parameters['mxsize'])>0)&&(isset($ex_ad->parameters['mxtype']))) {
							if((($ex_ad->parameters['mxtype'] == 'w')&&($ex_ad->parameters['mxsize'] < $zparams['width']))||($zparams['width'] == '')){
								//$ratio = $zparams['width']/$zparams['height'];$zparams['height'] = $zparams['width']/$ratio;
								$zparams['width'] = $ex_ad->parameters['mxsize'];
							} elseif((($ex_ad->parameters['mxtype'] == 'h')&&($ex_ad->parameters['mxsize'] < $ex_ad->parameters['height']))||($zparams['height'] == '')){
								//$ratio = $zparams['width']/$zparams['height'];$zparams['width'] = $ratio * $zparams['height'];
								$zparams['height'] = $ex_ad->parameters['mxsize'];
							}
								
							if(isset($zparams['width']) && isset($zparams['height']) && isset($width_orig) && ($width_orig != NULL) && isset($height_orig) && (($width_orig > $zparams['width'])||($height_orig > $zparams['height'])) ) {
								// make the thumb with the maximum size or the zone
								//echo "Campaign id: ".$val."<br />";
								$thumb = $this->makeThumb($img_url, $zparams['width'], $zparams['height']);
								if(($thumb != NULL)&&($thumb != false)) { 
									$sql = "UPDATE `#__ad_agency_campaign_banner` SET `thumb` = '".$thumb."' WHERE `campaign_id` =".$val." AND `banner_id` =".$idi.";";
								} else {
									$sql = "UPDATE `#__ad_agency_campaign_banner` SET `thumb` = NULL WHERE `campaign_id` =".$val." AND `banner_id` =".$idi.";";
								}
								$db->setQuery($sql);
								$db->query();

								$fls[] = $thumb;
							}
						}
					}
				}			
			}
		}
		//echo "<hr />";	
		//var_dump($fls);		
		//die();
		
		// Send email to administrator
		if ($notify=='0') {
			$sql = "SELECT a.user_id, a.company, a.telephone AS phone, u.name, u.username, u.email FROM #__ad_agency_advertis AS a LEFT OUTER JOIN #__users AS u ON u.id=a.user_id	WHERE a.aid={$advid} GROUP BY a.aid";			
			$db->setQuery($sql);	
			$user = $db->loadObject();
			if(isset($user)&&($user!=NULL)){
				$subject=$configs->sbnewad;
				$message=$configs->bodynewad;
				if(!isset($user->company)||($user->company=="")){$user->company = "N/A";}
				if(!isset($user->phone)||($user->phone=="")){$user->phone = "N/A";}	
				
				$current_ad = $this->getAdById($idi);
				if(isset($current_ad->approved)&&($current_ad->approved == "Y")) { $status = JText::_("NEWADAPPROVED");} else { $status = JText::_("ADAG_PENDING");}
				
				$epreview = "<a href='".JURI::root()."index.php?option=com_adagency&controller=adagencyAds&task=preview&tmpl=component&no_html=1&adid=".$idi."' target='_blank'>".JURI::root()."index.php?option=com_adagency&controller=adagencyAds&task=preview&tmpl=component&adid=".$idi."</a>";
				$eapprove = "<a href='".JURI::root()."index.php?option=com_adagency&controller=adagencyAds&task=manage&action=approve&cid=".$idi."&key=".$data['key']."' target='_blank'>".JURI::root()."index.php?option=com_adagency&controller=adagencyAds&task=manage&action=approve&cid=".$idi."&key=".$data['key']."</a>";
				$edecline = "<a href='".JURI::root()."index.php?option=com_adagency&controller=adagencyAds&task=manage&action=decline&cid=".$idi."&key=".$data['key']."' target='_blank'>".JURI::root()."index.php?option=com_adagency&controller=adagencyAds&task=manage&action=decline&cid=".$idi."&key=".$data['key']."</a>";
				
				$subject =str_replace('{name}',$user->name,$subject);
				$subject =str_replace('{login}',$user->username,$subject);	
				$subject =str_replace('{email}',$user->email,$subject);
				$subject =str_replace('{banner}',$data['title'],$subject);
				$subject =str_replace('{company}',$user->company,$subject);
				$subject =str_replace('{phone}',$user->phone,$subject);
				$subject =str_replace('{approval_status}',$status,$subject);
				$subject =str_replace('{banner_preview_url}',$epreview,$subject);
				$subject =str_replace('{approve_banner_url}',$eapprove,$subject);
				$subject =str_replace('{decline_banner_url}',$edecline,$subject);
				
				$message =str_replace('{name}',$user->name,$message);
				$message =str_replace('{login}',$user->username,$message);
				$message =str_replace('{email}',$user->email,$message);
				$message =str_replace('{banner}',$data['title'],$message);
				$message =str_replace('{company}',$user->company,$message);
				$message =str_replace('{phone}',$user->phone,$message);
				$message =str_replace('{approval_status}',$status,$message);
				$message =str_replace('{banner_preview_url}',$epreview,$message);
				$message =str_replace('{approve_banner_url}',$eapprove,$message);
				$message =str_replace('{decline_banner_url}',$edecline,$message);
			
				JUtility::sendMail( $configs->fromemail, $configs->fromname, $configs->adminemail, $subject, $message, 1 );		
			} 						
		}
		// END - Send email to administrator
		
		$sql = "SELECT approved FROM #__ad_agency_banners WHERE id = ".$idi;
		$db->setQuery($sql);
		$approved = $db->loadResult();
		
		$isWizzard = $this->isWizzard();
		
		$item_id = JRequest::getInt('Itemid','0');
		if($item_id != 0) { $Itemid = "&Itemid=".$item_id; } else { $Itemid = NULL; }
		
		$link = "index.php?option=com_adagency&controller=adagencyAds&p=1".$Itemid;
		$msg = JText::_('AD_BANNERSAVED');
		global $mainframe;
		if($isWizzard && $approved=='P'){
			$mainframe->redirect($link,$msg);
		}
			
		return $res;

	}
	
		
	function makeThumb($file_url, $width, $height){
		$handle = new Upload($file_url);
		
		list($width_orig, $height_orig) = @getimagesize($file_url);
		if(!isset($width_orig)||($width_orig == NULL)) { return false; }
		$ratio_orig = $width_orig/$height_orig;
		if($width == '') { $width = $height*$ratio_orig; }
		elseif($height == '') { $height = $width/$ratio_orig; }
		if ($width/$height > $ratio_orig) {
		   $width = $height*$ratio_orig;
		} else {
		   $height = $width/$ratio_orig;
		}

		$check['width'] = (int)$width;
		$check['height'] = (int)$height;
		if(($check['width'] == 0)&&($check['height'] == 0)){
			return NULL;
		}		
		
		$width = number_format($width,0);
		$height = number_format($height,0);

		$pieces = explode(DS,$file_url);
		$filename = explode('.',$pieces[count($pieces)-1]);
		$pieces[count($pieces)-1] = '';
		$pieces = implode(DS,$pieces);
		$dir_dest = $pieces;

		if ($handle->uploaded) {
			$handle->image_resize			= true;
			$handle->image_x				= $width;
			$handle->image_y				= $height;
			$handle->file_new_name_body		= $filename[0].'_w'.$width.'_h'.$height;
			$handle->file_overwrite			= true;
			$handle->jpeg_quality 			= 100;

			$handle->Process($dir_dest);
			if ($handle->processed) {
				return $handle->file_dst_name;
			}  else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	function gettextlistAdvertisers () {
		if (empty ($this->_package)) {
			$db =& JFactory::getDBO();
			$sql = "SELECT a.aid, a.company, a.user_id FROM #__ad_agency_advertis AS a, #__users AS b WHERE a.user_id = b.id ORDER BY a.company ASC";
			$db->setQuery($sql);
			if (!$db->query()) {
				echo $db->stderr();
				return;
			}
			$this->_package = $db->loadObjectList();
			
		}
		return $this->_package;
	}
	
	function isWizzard(){
		$db = & JFactory::getDBO();	
		$sql = "SELECT `show` FROM #__ad_agency_settings ORDER BY id LIMIT 1";
		$db->setQuery($sql);
		$shown = $db->loadResult();
		$shown = explode(";",$shown);
		$isWizzard = false;
		foreach($shown as $element){
			if($element == "wizzard") { $isWizzard = true; }
		}
		return $isWizzard;
	}
	
};
?>